c****************************************************************************
	SUBROUTINE GETLINE(LINE,NCHAR,NWORD,WORD,WORDLEN)
C
C		GETLINE will break the character string LINE of length
C		CHAR, in NWORD separate words, each of length WORDLEN.
C
C			For instance
C	USER3:[DUMMY]  120  1  2345.456
C
C		will be returned as NWORD=4,
C		WORD(1)='USER3:[DUMMY], WORDLEN(1)=12,
C		WORD(2)='120',         WORDLEN(2)=3, etc.
	INTEGER*2 NWORD, WORDLEN(1)
	CHARACTER*(*) WORD(1)
	CHARACTER*(*) LINE
C
C		Initialize some variables
	NWORD=0
C
C		Get rid of leading   blanks
100	IF (LINE(1:1).NE.' ') GO TO 200
C		Shift left one character
	NCHAR=NCHAR-1
C		Is there anything left?
	IF (NCHAR.EQ.0) THEN
				NWORD=0
				RETURN
	END IF
	DO 150 I=1, NCHAR
	LINE(I:I)=LINE(I+1:I+1)
150	CONTINUE
C		See if there is still a blank
	GO TO 100
C		Here we have a non blank character
200	CONTINUE
C		Start number of NWORD counter
	NWORD=NWORD+1
C
C		Find the position of the first blank
	I_BLANK=INDEX(LINE(:NCHAR), ' ')
C		If I_BLANK.EQ.0 means there are no blanks. Thus
C		there is only one key_word of length NCHAR
	IF (I_BLANK.EQ.0) THEN
			WORD(NWORD)=LINE(:NCHAR)
			WORDLEN(NWORD)=NCHAR
			RETURN
	END IF
C		I_BLANK.NE.0 means there may be more key_words
C		The LEN of the key_word is I_BLANK
	WORD(NWORD)=LINE(:I_BLANK-1)
	WORDLEN(NWORD)=I_BLANK-1
C
C		Remove the KEY_WORD from the input string
	LINE=LINE(I_BLANK+1:)
250	CONTINUE
	NCHAR=NCHAR-I_BLANK
C		If NCHAR.EQ.0 we have finished
	IF (NCHAR.LE.0) RETURN
C		Otherwise
	GO TO 100
	END

