c------------------------------------------------------------------------
cA.Bijaoui	85/2	Nice Observatory
c	Allows to do a 2d polynomial fitting with homogeneous variables
	Subroutine Saiad3(Xval, Yval, Zval, Pval, Nval, Ndeg, Nterm, Coe, Rval,
	1 Dval, Sig, Nxy, Nterm1, Aux1, Aux2)
cXval	R*4(Nval)	I	Array of first variable
cYval	R*4(Nval)	I	Array of second variable
cZval	R*4(Nval)	I	Corresponding values to fit
cPval	R*4(Nval)	I	Corresponding weights
cNval	I*4	I	Number of values
cNdeg	I*4	I	Degree of the homogeneous polynomial
cNterm	I*4	I	Number of terms of the polynomial (Ndeg+1)(Ndeg+2)/2
cCoe	R*4(Nterm)	O	Coefficients array
cRval	R*4(Nval)	O	Array of resulting data fitting
cDval	R*4(Nval)	O	Differences between Measured and computed data
cSig	R*4	O	Mean residue
cNxy	I*4	I	(Ndeg+1)(2*Ndeg+1)
cNterm1	I*4	I	Nterm+1
cAux1	R*8(Nxy)	O	Aux array
cAux2	R*8(Nterm1,Nterm)	O	Aux array
	Real*4 Xval(Nval), Yval(Nval), Zval(Nval), Pval(Nval), Coe(Nterm),
	1 Rval(Nval), Dval(Nval)
	Real*8 Aux1(Nxy), Aux2(Nterm1,Nterm)
	Call Mpmcar2(Xval, Yval, Zval, Pval, Nval, Coe, Ndeg, Nxy, Nterm,
	1 Nterm1, Aux1, Aux2)
	s=0.
	Sig=0.
	Nsig=0
	Do Ival=1,Nval
	  call Ph3(Rval(Ival),Xval(Ival),Yval(Ival),Ndeg,Coe)
	  Dval(Ival)=Zval(Ival)-Rval(Ival)
	  If(Pval(Ival).ne.0.) then
	    Sig=Sig+Dval(Ival)**2
	    Nsig=Nsig+1
	  endif
	Enddo
	Sig=sqrt(sig/float(Nsig))
	Return
	End
c	a.bijaoui 28 juin 1974
c	Pmcar2 permet d'effectuer un ajustement polynomial homogene a deux
c	dimensions
	subroutine MPMCAR2(xx,yy,d,p,n,coe,ndeg,nxy,nterm,nterm1,xy,matr)
	real*4 xx(1),yy(1),d(1),coe(1),p(1)
c	xx	tableau des abcisses
c	yy	tableau des ordonnees
c	p	Weights array
c	d	tableau des mesures a ajuster
c	n	nombre de mesures
c	coe	tableau des coefficients d'ajustement
c	ndeg	degre max du polynome homogene d=p(x,y) (<10)
cNxy	I*4	I	Dimension of XY array (Ndeg+1)(2Ndeg+1)
cNterm	I*4	I	Number of output coefficients (Ndeg+1)(Ndeg+2)/2
cNterm1	I*4	I	Nterm+1
cXY	R*8(Nxy)	O	Aux array
cMatr	R*8(Nterm1,Nterm)	O	Aux Array
	Real*8 s,xy(nxy),matr(nterm1,nterm),Pivot
c	calcul de la matrice des produits
	ndeg2=2*ndeg
	lmax=((ndeg+1)*(ndeg+2))/2
	lmax1=lmax+1
	do ix=0,ndeg2
	do iy=0,ndeg2
		k=ix+iy
		if(k.le.ndeg2) then
			l=(k*(k+1))/2+ix+1
			s=0.
			do i=1,n
			  if(ix.eq.0) then
			    if(iy.eq.0) then
			      s=s+p(i)
			    else
			      if(yy(i).ne.0.) then
				s=s+(yy(i)**iy)*p(i)
			      endif
			    endif
			  else
			    if(iy.eq.0) then
			      if(xx(i).ne.0.) then
				s=s+(xx(i)**ix)*p(i)
			      endif
			    else
			      if((xx(i).ne.0.).and.(yy(i).ne.0.)) then
				s=s+(xx(i)**ix)*(yy(i)**iy)*p(i)
			      endif
			    endif
			  endif
			enddo
			xy(l)=s
		endif
	enddo
	enddo
	do ix1=0,ndeg
	do iy1=0,ndeg
		k1=ix1+iy1
		if(k1.le.ndeg) then
			l1=(k1*(k1+1))/2+ix1+1
			do ix2=0,ndeg
			do iy2=0,ndeg
				k2=ix2+iy2
				if(k2.le.ndeg) then 
					l2=(k2*(k2+1))/2+ix2+1
					k3=k1+k2
					ix3=ix1+ix2
					l3=(k3*(k3+1))/2+ix3+1
					matr(l1,l2)=xy(l3)
				endif
			enddo
			enddo
		endif
	enddo
	enddo
c	calcul des sommes
	do ix=0,ndeg
	do iy=0,ndeg
	k=ix+iy
	if(k.le.ndeg) then
		l=(k*(k+1))/2+ix+1
		s=0.
		do i=1,n
			  if(ix.eq.0) then
			    if(iy.eq.0) then
			      s=s+d(i)*p(i)
			    else
			      if(yy(i).ne.0.) then
				s=s+p(i)*d(i)*yy(i)**iy
			      endif
			    endif
			  else
			    if(iy.eq.0) then
			      if(xx(i).ne.0.) then
				s=s+p(i)*d(i)*xx(i)**ix
			      endif
			    else
			      if((xx(i).ne.0.).and.(yy(i).ne.0.)) then
				s=s+p(i)*d(i)*(xx(i)**ix)*(yy(i)**iy)
			      endif
			    endif
			  endif
		enddo
		matr(lmax1,l)=s
		endif
	enddo
	enddo
c	resolution du systeme som=matr*coe
c	copie de PMCAR (?)
	do i=1,lmax
		pivot=matr(i,i)
		do m=1,lmax
			matr(m+1,i)=matr(m+1,i)/pivot
		enddo
		do k=1,lmax
			if(i.ne.k) then
				pivot=matr(i,k)
				do m=1,lmax
		matr(m+1,k)=matr(m+1,k)-matr(m+1,i)*pivot
				enddo
			endif
		enddo
	enddo
	do i=1,lmax
		coe(i)=matr(lmax1,i)
	enddo
	return
	end
c Subroutine Ph3 to compute the value for a homogeneous polynomial
	Subroutine Ph3(z, x, y, ndeg, coe)
cz	R*4	O	Result
cx	R*4	I	1st coordinate
cy	R*4	I	2nd coordinate
cnd	I*4	I	Degree of the homogeneous polynomial
cCoe	R*4(1)	I	Coefficients Array
	Real*4 Coe(1)
	z=0.
	zz=1.
	do ix=0,Ndeg
	  tt=1.
	  do iy=0,Ndeg
	    k=ix+iy
	    if(k.le.Ndeg) then
	      l=(k*(k+1)/2)+ix+1
	      z=z+coe(l)*zz*tt
	      tt=tt*y
	    endif
	  enddo
	  zz=zz*x
	enddo
	return
	end
