c-----------------------------------------------------------------------------
c	A.Bijaoui Nice Observatory 85/1
c	SaiBi1 : Special structural lines in an image
	Subroutine SaiBi1(ImageIn, Ncolumns, Nlines, ImageOut,
	1 Option, Step,Inverse)
c	ImageIn		Working Image
c	Ncolumns	Corresponding number of columns
c	Nlines		Corresponding number of lines
c	ImageOut	Resulting Image
c	Option		Working Option
c	1	Egde Bijaoui-Froeschle
c	2	Line of isophots inflexions
c	3	Line of isophots minimum curvature
c	4	Laplacian
c	5	x derivative
c	6	y derivative
c	7	Gradient
c	8	Relative gradient
	Real*4	ImageIn(Ncolumns,Nlines), ImageOut(Ncolumns, Nlines)
	Integer*4 Option, Step
	Do Iline=1,Nlines
	  Il1=Max0(Iline-Step,1)
	  Il2=Iline
	  Il3=Min0(ILine+Step,Nlines)
	  Do Icolumn=1,Ncolumns
	    Ic1=Max0(Icolumn-step,1)
	    Ic2=Icolumn
	    Ic3=Min0(Icolumn+Step,Ncolumns)
	    S0=ImageIn(Ic1,Il1)+ImageIn(Ic2,Il1)+ImageIn(Ic3,Il1)+
	1       ImageIn(Ic1,Il2)+ImageIn(Ic2,Il2)+ImageIn(Ic3,Il2)+
	2       ImageIn(Ic1,Il3)+ImageIn(Ic2,Il3)+ImageIn(Ic3,Il3)
	    Sx=-ImageIn(Ic1,Il1)+ImageIn(Ic3,Il1)-ImageIn(Ic1,Il2)+
	1       ImageIn(Ic3,Il2)-ImageIn(Ic1,Il3)+ImageIn(Ic3,Il3)
	    Sy=-ImageIn(Ic1,Il1)-ImageIn(Ic2,Il1)-ImageIn(Ic3,Il1)+
	1        ImageIn(Ic1,Il3)+ImageIn(Ic2,Il3)+ImageIn(Ic3,Il3)
	    Sxy=ImageIn(Ic1,Il1)-ImageIn(Ic3,Il1)-ImageIn(Ic1,Il3)+
	1        ImageIn(Ic3,Il3)
	    Sx2=ImageIn(Ic1,Il1)+ImageIn(Ic3,Il1)+ImageIn(Ic1,Il2)+
	1        ImageIn(Ic3,Il2)+ImageIn(Ic1,Il3)+ImageIn(Ic3,Il3)
	    Sy2=ImageIn(Ic1,Il1)+ImageIn(Ic2,Il1)+ImageIn(Ic3,Il1)+
	1        ImageIn(Ic1,Il3)+ImageIn(Ic2,Il3)+ImageIn(Ic3,Il3)
	    A=5.*s0/9.-Sx2/3.-Sy2/3.
	    B=Sx/6.
	    C=Sy/6.
	    D=-s0/3.+0.5*Sx2
	    E=-S0/3.+0.5*Sy2
	    F=0.25*Sxy
	    G=b*b+c*c
	    Goto(1,2,3,4,5,6,7,8),Option
1	    s=b*b*d+c*c*e+b*c*f
	    if(g.eq.0.) then
	      ImageOut(Icolumn,Iline)=0.
	    else
	      ImageOut(Icolumn,Iline)=s/g
	    endif
	    goto 10
2	    s=c*c*d+b*b*e-b*c*f
	    if(g.eq.0.) then
	      ImageOut(Icolumn,Iline)=0.
	    else
	      ImageOut(Icolumn,Iline)=s/g
	    endif
	    goto 10
3	    s=f*(b*b-c*c)-b*c*(d-e)
	    if(g.eq.0.) then
	      ImageOut(Icolumn,Iline)=0.
	    else
	      ImageOut(Icolumn,Iline)=s/g
	    endif
	    goto 10
4	    ImageOut(Icolumn,Iline)=d+e
	    goto 10
5	    ImageOut(Icolumn,Iine)=B
	    goto 10
6	    ImageOut(Icolumn,Iline)=C
	    Goto 10
7	    ImageOut(Icolumn,Iline)=G
	    Goto 10
8	    s=a
	    if(g.eq.0.) then
	      ImageOut(Icolumn,Iline)=0.
	    else
	      ImageOut(Icolumn,Iline)=s/g
	    endif
10	    If(Inverse.eq.1) ImageOut(Icolumn,Iline)=-ImageOut(Icolumn,Iline)
	  enddo
	enddo
	return	    
	end
