c.ps 60,68
c.hl 1 Valleys lines determination
c.x SAI
c.x Valleys lines> Determination
c.nf.ts 14,32
cA.Bijaoui	85/3	Nice Observatory
c.f
c.ap ! But, Methode et Algorithme
c	Allows to determine the network of the Valleys lines of an image. The
cprogram determines all the saddle points and give the lines by following the
cminimum at each step. This walk stops when it arrives to a minimum or at a
cpoint of preceeding valley line.
c	The output is a label table in which pixel value is 0 in  general
cbut 1 for points of valley lines.
c.b.c; ^&Subroutines Used\&
c.nf.b.ts 16
cSpecial	Marc
c.f
c.b.c; ^&Call and Parameters\&
c.b;CALL SAIBi2(ImageIn, Ncolumns, Nlines, Label)
c.b
c.nf.ts 14,27,30
cImageIn	R*4(Ncolumns,Nlines)	I	Input Image
cNcolumns	I*4	I	Corresponding number of columns
cNlines	I*4	I	Corresponding number of lines
cLabel	I*4(Ncolumns,Nlines)	O	Output Label Table
c.f
	Subroutine SaiBi2(ImageIn, Ncolumns, Nlines, Label)
	Real*4 ImageIn(Ncolumns,Nlines)
	Integer*4 Label(Ncolumns,Nlines)
	Logical*1 MinColumn, MaxColumn, MinLine, MaxLine
	Do Iline=1,Nlines
	  Do Icolumn=1,Ncolumns
	    Label(Icolumn,Iline)=1
	  Enddo
	Enddo
	Nline1=Nlines-1
	Ncolumn1=Ncolumns-1
	Do Iline=2,Nline1
	  Il1=Max0(Iline-1,1)
	  Il2=Min0(Iline+1,Nlines)
	  Do Icolumn=2,Ncolumn1
	    Ic1=Max0(Icolumn-1,1)
	    Ic2=Min0(Icolumn+1,Ncolumns)
	    MinColumn=.false.
	    MaxColumn=.false.
	    MinLine=.false.
	    MaxLine=.false.
	    If(ImageIn(Ic1,Iline).lt.ImageIn(Icolumn,Iline).and.
	1 ImageIn(Icolumn,Iline).ge.ImageIn(Ic2,Iline)) MaxColumn=.true.
	    If(ImageIn(Ic1,Iline).ge.ImageIn(Icolumn,Iline).and.
	1 ImageIn(Icolumn,Iline).lt.ImageIn(Ic2,Iline)) MinColumn=.true.
	    If(ImageIn(Icolumn,Il1).lt.ImageIn(Icolumn,Iline).and.
	1 ImageIn(Icolumn,Iline).ge.ImageIn(Icolumn,Il2)) MaxLine=.true.
	    If(ImageIn(Icolumn,Il1).ge.ImageIn(Icolumn,Iline).and.
	1 ImageIn(Icolumn,Iline).lt.ImageIn(Icolumn,Il2)) MinLine=.true.
	    If(MaxColumn.and.MinLine) then
c	type 100
c100	format(' maxcolumn et minline')
	      Do K=1,2
	        IcStart=Icolumn
	        IlStart=Iline
		Label(Icstart,Ilstart)=-1
	        IcEnd=Icolumn+2*K-3
	        If(Icend.ge.1.or.IcEnd.le.Ncolumns) then
	          IlEnd=Iline
		  Label(Icend,Ilend)=-1
	          Call Marc(IcStart,IcEnd,IlStart,IlEnd,ImageIn,Label,Ncolumns,
	1                   Nlines)
	        Endif
	      Enddo
	    Endif
	    If(MinColumn.and.MaxLine) then
c	type 101
c101	format(' Mincolumn et Maxline')
	      Do K=1,2
	        IlStart=Iline
	        IlEnd=Iline+2*K-3
	        IcStart=Icolumn
		Label(Icstart,Ilstart)=-1
	        If(Ilend.ge.1.or.IlEnd.le.Nlines) then
	          IcEnd=Icolumn
		  Label(Icend,Ilend)=-1
	          Call Marc(IcStart,IcEnd,IlStart,IlEnd,ImageIn,Label,Ncolumns,
	1                   Nlines)
	        Endif
	      Enddo
	    Endif
	  Enddo
	Enddo
	Do Iline=2,Nlines
	  Do Icolumn=2,Ncolumns
	    Dif1=ImageIn(Icolumn,Iline-1)-ImageIn(Icolumn,Iline)
	    Dif2=ImageIn(Icolumn-1,Iline)-ImageIn(Icolumn,Iline)
	    Dif3=ImageIn(Icolumn-1,Iline-1)-ImageIn(Icolumn-1,Iline)
	    Dif4=ImageIn(Icolumn-1,Iline-1)-ImageIn(Icolumn,Iline-1)
	    Flag1=Sign(1.,Dif1)*Sign(1.,Dif3)
	    Flag2=Sign(1.,Dif2)*Sign(1.,Dif4)
	    If(Flag1.eq.-1..and.Flag2.eq.-1.) Then
c	type *,Flag1,Flag2,Dif3
	      If(Dif3.lt.0.) then
	        Label(Icolumn-1,Iline-1)=-1
	        Label(Icolumn,Iline)=-1
	        Do K=1,2
	          IcStart=Icolumn+k-2
	          IcEnd=Icolumn+(3-k)*(2*k-3)
		  IlStart=Iline+k-2
	          Ilend=Iline+(3-k)*(2*k-3)
		  IcEnd=Min0(Ncolumns,IcEnd)
		  IcEnd=Max0(1,IcEnd)
		  IlEnd=Min0(Nlines,Ilend)
		  IlEnd=Max0(1,Ilend)
		  Label(Icstart,Ilstart)=-1
		  Label(Icend,Ilend)=-1
	          Call Marc(IcStart,IcEnd,IlStart,IlEnd,ImageIn,Label,Ncolumns,
	1                   Nlines)
		Enddo
	      Else
	        Label(Icolumn,Iline-1)=-1
	        Label(Icolumn-1,Iline)=-1
	        Do K=1,2
	          IcStart=Icolumn+k-2
	          IcEnd=Icolumn+(3-k)*(2*k-3)
		  IlStart=Iline-k+1
	          Ilend=Iline+(3-2*k)*k
		  IcEnd=Min0(Ncolumns,IcEnd)
		  IcEnd=Max0(1,IcEnd)
		  IlEnd=Min0(Nlines,Ilend)
		  IlEnd=Max0(1,Ilend)
		  Label(Icstart,Ilstart)=-1
		  Label(Icend,Ilend)=-1
	          Call Marc(IcStart,IcEnd,IlStart,IlEnd,ImageIn,Label,Ncolumns,
	1                   Nlines)
		Enddo
	      Endif
	    Endif
	  Enddo
	Enddo
	Return
	End
	Subroutine Marc(IcStart,IcEnd,IlStart,Ilend,ImageIn,Label,Ncolumns
	1 ,Nlines)
	Real*4 ImageIn(Ncolumns,Nlines)
	Integer*4 Label(Ncolumns,Nlines)
100	Continue
	Value=ImageIn(IcEnd,IlEnd)
	IcNew=Icend
	IlNew=IlEnd
	Ic=IcEnd-1
	If(Ic.ne.0) then
	  If(Ic.ne.ICStart.or.IlEnd.ne.Ilstart) then
	    If(ImageIn(Ic,Ilend).lt.Value) then
	      Value=ImageIn(Ic,Ilend)
	      IcNew=Ic
	      Ilnew=Ilend
	    Endif
	  Endif
	Endif
	Ic=IcEnd+1
	If(Ic.le.Ncolumns) then
	  If(Ic.ne.ICStart.or.IlEnd.ne.Ilstart) then
	    If(ImageIn(Ic,Ilend).lt.Value) then
	      Value=ImageIn(Ic,Ilend)
	      IcNew=Ic
	      Ilnew=Ilend
	    Endif
	  Endif
	Endif
	Il=IlEnd-1
	If(Il.ne.0) then
	  If(Il.ne.IlStart.or.IcEnd.ne.Icstart) then
	    If(ImageIn(Icend,Il).lt.Value) then
	      Value=ImageIn(Icend,Il)
	      Icnew=Icend
	      IlNew=Il
	    Endif
	  Endif
	Endif
	Il=IlEnd+1
	If(Il.le.Nlines) then
	  If(Il.ne.IlStart.or.IcEnd.ne.Icstart) then
	    If(ImageIn(Icend,Il).lt.Value) then
	      Value=ImageIn(Icend,Il)
	      Icnew=Icend
	      IlNew=Il
	    Endif
	  Endif
	Endif
	If(Label(IcNew,IlNew).eq.-1) Return
	Label(IcNew,IlNew)=-1
	if((Icnew.eq.IcEnd).and.(Ilnew.eq.Ilend)) return
	IcStart=IcEnd
	IlStart=IlEnd
	IcEnd=IcNew
	IlEnd=IlNew
	Goto 100
	End
