c.ps 60,68
c.hl 1 Curve fitting with an ellipsis
c.x SAICU1
c.x Curve fitting> with an ellipsis
c.nf.ts 14,32
cA.Bijaoui	85/3	Nice Observatory
c	Adapted from M.Froechle's program "Elli2"
c.f
c.ap
c	Allows to fitting a curve, described by a set a corresponding points,
cwith an ellipsis.
c.b.c; ^&Subroutines Used\&
c.nf.b.ts 16
cSpecial	Rslin
c.f
c.b.c; ^&Call and Parameters\&
c.b;CALL SAICU1(Ncurve, Xcurve, Ycurve, MajorAxis, MinorAxis, Orientation,
cXcenter, Ycenter)
c.b
c.nf.ts 14,27,30
cNcurve	I*4	I	Number of given points on the curve
cXcurve	R*4(Ncurve)	I	Corresponding Abcissae
cYcurve	R*4(Ncurve)	I	Corresponding Ordinates
cMajorAxis	R*4	O	Ellipsis major axis
cMinorAxis	R*4	O	Ellipsis minor axis
cOrientation	R*4	O	Orientation of the major axis in degrees
cXcenter	R*4	O	Central ellipsis abcissa
cYcenter	R*4	O	Central ellipsis ordinate
c.f
	Subroutine SAICU1(Ncurve, Xcurve, Ycurve, MajorAxis, MinorAxis,
	1 Orientation, Xcenter, Ycenter)
 	DOUBLE PRECISION UM(5,6)
 	DOUBLE PRECISION DM,CH,HT,AP,BP
 	DOUBLE PRECISION TX,TY,TZ,AL,HTP
	Real*4 HH(6), Xcurve(Ncurve), Ycurve(Ncurve)
	Real*4 MajorAxis, MinorAxis
	Do i=1,5
	  Do j=1,6
	    Um(i,j)=0.
	  Enddo
	Enddo
 	XG=0.
 	YG=0.
        DO ICurve=1,Ncurve        
 	  XG=XG+Xcurve(ICurve)
	  YG=YG+Ycurve(Icurve)
	Enddo
 	XG=XG/FLOAT(Ncurve)
 	YG=YG/FLOAT(Ncurve)
 	DO ICurve=1,Ncurve
 	  XX=Xcurve(Icurve)-XG
 	  YY=Ycurve(Icurve)-YG
          HH(1)=XX*XX
          HH(2)=2.*XX*YY
          HH(3)=YY*YY
          HH(4)=2.*XX
          HH(5)=2.*YY
  	  HH(6)=1.
          DO J=1,5         
 	    DO K=1,J
 	      UM(J,K)=UM(J,K)+HH(J)*HH(K)        
	    Enddo
            UM(J,6)=UM(J,6)+HH(J)*HH(6)
	  Enddo
	Enddo
        DO I=1,5       
          DO J=1,5        
            UM(I,J)=UM(J,I)
	  enddo
	enddo
	call slin(um)
         DM=UM(1,1)*UM(3,1)-UM(2,1)**2       
         XX=(UM(2,1)*UM(5,1)-UM(3,1)*UM(4,1))/DM         
         YY=(UM(4,1)*UM(2,1)-UM(1,1)*UM(5,1))/DM         
 	Xcenter=XX+XG
 	Ycenter=YY+YG
         CH=UM(4,1)*XX+UM(5,1)*YY-1.       
         HT=-CH            
 	TX=UM(3,1)-UM(1,1)
 	TY=DSQRT(TX**2+4.*UM(2,1)**2)
 	TZ=(TX+TY)/(2.*UM(2,1))
 	AL=DATAN(TZ)
 	AP=UM(1,1)*DCOS(AL)**2+2.*UM(2,1)*DCOS(AL)*DSIN(AL)
	1+UM(3,1)*DSIN(AL)**2
 	BP=UM(1,1)*DSIN(AL)**2-2.*UM(2,1)*DCOS(AL)*DSIN(AL)
	1+UM(3,1)*DCOS(AL)**2
 	HTP=HT/AP
 	ZZZ=HTP
 	MajorAxis=SQRT(ZZZ)
 	HTP=HT/BP
 	ZZZ=HTP
 	MinorAxis=SQRT(ZZZ)
        Orientation=AL/0.0174533
	If(MajorAxis.lt.MinorAxis) then
	  Aux=MajorAxis
	  MajorAxis=MinorAxis
	  MinorAxis=Aux
	  Orientation=Orientation+90.
	Endif
 	RETURN
 	END
 	SUBROUTINE SLIN(AA)
 	DOUBLE PRECISION AA(5,6),BB(5,6),CC(6)
	n=5
	k=6
 	N1=N-1
 	K1=K-1
 	DO 100 I=1,N
 	DO 100 J=1,K
 100	BB(I,J)=AA(I,J)
 	DO 3 L=1,N
 	IF(AA(1,1)) 4,5,4
 5	STOP
 4	DO 6 J=1,K1
 6	CC(J)=AA(1,J+1)/AA(1,1)
 	CC(K)=1./AA(1,1)
 	DO 7 I=1,N1
 	DO 8 J=1,K1
 8	AA(I,J)=AA(I+1,J+1)-AA(I+1,1)*CC(J)
 7	AA(I,K)=-AA(I+1,1)*CC(K)
 	DO 3 J=1,K
 3	AA(N,J)=CC(J)
 	RETURN
 	END
