c.ps 60,68
c.hl 1 Contour from a set of points
c.x SAICU2
c.x Contour > from a set of points
c.nf.ts 14,32
cA.Bijaoui	85/3	Nice Observatory
c.f
c.ap
c	Allows to determine the set of succesive points in a contour,
cfrom a set of points belonging to the curve.
c	The algorithm uses a dichotomic process, determining at each step
cthe central point of the arc formed by two successive points. A spline
cinterpolation is used to determined the central point (4 points interpolation)
c.b.c; ^&Call and Parameters\&
c.b;CALL SAICu2(Ncurve, Xcurve, Ycurve, Ncm, distance, Xn, Yn, Num)
c.b
c.nf.ts 14,27,30
cNcurve	I*4	I/O	Number of points of the curve (input and Output)
cXcurve	R*4(1)	I/O	Abcissae array
cYcurve	R*4(1)	I/O	Ordinates array
cDistance	R*4	I	Minimum distance in x and y between two
c			output points
cXn	R*4(1)	O	Auxiliary array
cYn	R*4(1)	O	Auxiliary array
cNum	I*4(1)	O	Auxiliary array
c.f
	Subroutine SaiCu2(Ncurve,Xcurve,Ycurve,distance,Xn,Yn,Num)
	Real*4 Xcurve(1), Ycurve(1), Xn(1), Yn(1)
	Integer*4 Num(1)
 19	NK=0
 	Xcurve(Ncurve+1)=Xcurve(1)
 	Xcurve(Ncurve+2)=Xcurve(2)
 	Ycurve(Ncurve+1)=Ycurve(1)
 	Ycurve(Ncurve+2)=Ycurve(2)
 	DO  Icurve=1,Ncurve
 	  DIST=AMAX1(ABS(Xcurve(Icurve)-Xcurve(Icurve+1)),
	1 ABS(Ycurve(Icurve)-Ycurve(Icurve+1)))
 	  IF(DIST.ge.distance) then
 	    NK=NK+1
	    NUM(NK)=Icurve
	    If(Icurve.eq.1) then
	      X1=Xcurve(Ncurve)
	      Y1=Ycurve(Ncurve)
	    else
	      X1=Xcurve(Icurve-1)
	      Y1=Ycurve(Icurve-1)
	    endif
 	    XN(NK)=(-X1+9.*Xcurve(Icurve)+9.*Xcurve(Icurve+1)
	1          -Xcurve(Icurve+2))/16.
 	    YN(NK)=(-Y1+9.*(Ycurve(Icurve)+Ycurve(Icurve+1))
	1          -Ycurve(Icurve+2))/16.
	  endif
	enddo
 	IF(NK.ne.0) then
 	  DO IK=1,NK
 	    N=NUM(IK)
 	    IF(N.ne.Ncurve) then
	      N1=N+1
 	      DO I=N1,Ncurve
 	        IXY=Ncurve-I+N1+IK-1
 	        Xcurve(IXY+1)=Xcurve(IXY)
		Ycurve(IXY+1)=Ycurve(IXY)
	      enddo
	    endif
	    Xcurve(N+IK)=XN(IK)
	    Ycurve(N+IK)=YN(IK)
	  enddo
 	  Ncurve=Ncurve+NK
 	  GO TO 19
	endif
 	RETURN
 	END
