c--------------------------------------------------------------------------
c	a.bijaoui 85/1 Observatoire de Nice
c	Saidi10 allows to extract fields parameters using an image
c	segmentation by density thresholding
c	Mean pix value, standard deviation, and other statistical param.
	Subroutine SaiDi10(ImageIn, Ncolumns, Nlines, Threshold,  Label1, 
	1 Label2, Nfieldsmax, LabelInt, LabelFin, Labelflag, NfieldsInt,
	2 Nfields, Npixels, PixMean, PixSig, PixMax, PixS, PixC,
	3 Ia, Sd, Sd2, dmax, Sd3, Sd4)
c	ImageIn         = Image Initiale a segmenter
c	Ncolumns        = Nombre de colonnes de cette image
c	Nlines          = Nombre de lignes de cette image
c	Threshold	= Seuil de flux pour la segmentation
c	Label1		= labels of a line
c	Label2		= labels for the following line
c	Nfieldsmax	= Maximum number of fields
c	LabelInt	= Tableau 1d contenant pour chaque domaine l'etiquette
c			  Intermediaire associee
c	LabelFin	= Tableau 1d contenant pour chaque domaine l'etiquette
c			  Finale associee
c	LabelFlag	= array to determine if a field is closed
c	NfieldsInt	= Dimension maximum des Tableaux LabelInt,LabelFin
c		is Ncolumns/2 
c	Nfields         = Nombre de domaines etiquettes
c	Npixels		= Number of pixels in a field
c	Pixmean		= Corresponding mean pixel value
c	Pixsig		= Corresponding standard deviation
c	PixMax		= Corresponding maximum
c	PixS		= ------------- skewness (for moment order 3)
c	PixC		= ------------- curtosis (for moment order 4)
c	Ia		= Intermediate array for the area
c	Sd		= -------------------------- pix val
c	Sd2		= -------------------------- deviation
c	dmax		= -------------------------- maximum
c	sd3		= ------------------ skewness
c	sd4		= ------------------ curtosis
	Real*4 ImageIn(Ncolumns,Nlines), PixSig(Nfieldsmax),
	1 Pixmean(Nfieldsmax), Pixmax(Nfieldsmax), PixS(NFieldsMax),
	2 PixC(Nfieldsmax), Sd2(NfieldsInt), Sd3(NfieldsInt), Sd4(NfieldsInt),
	3 Sd(NfieldsInt), Dmax(NfieldsInt)
	Integer*4 LabelInt(NfieldsInt), LabelFin(NfieldsInt),
	1 Labelflag(NfieldsInt), Ia(NfieldsInt), Npixels(NfieldsMax),
	2 Label1(Ncolumns), Label2(Ncolumns)
	Nfieldsi=0
	Nfields=0
	Do icolumn=1,Ncolumns
	  Label1(icolumn)=0
	Enddo
	Do iline=1,Nlines
	  Do icolumn=1,Ncolumns
	    if(ImageIn(icolumn,Iline).le.threshold) then
	      Label2(Icolumn)=0
	    else
	      If(Icolumn.ne.1) then
	        l1=Label2(icolumn-1)
		If(l1.ne.0) Label2(icolumn)=l1
	      endif
	      if(iline.ne.1) then
		l2=Label1(icolumn)
		if(l1.eq.0) then
		  if(l2.eq.0) then
		     Nfieldsi=Nfieldsi+1
		     LabelInt(Nfieldsi)=Nfieldsi
		     Ia(Nfieldsi)=0
		     Sd(Nfieldsi)=0.
		     sd2(Nfieldsi)=0.
		     sd3(Nfieldsi)=0.
		     sd4(Nfieldsi)=0.
		     Dmax(Nfieldsi)=ImageIn(icolumn,Iline)-Threshold
		     Label2(icolumn)=Nfieldsi
	          else
	             Label2(icolumn)=l2
		  endif
		else
		  if(l2.ne.0) then
		    if(l2.ne.l1) then
		      call descen(LabelInt,l1,la1)
		      call descen(LabelInt,l2,la2)
		      la=min0(la1,la2)
		      LabelInt(la1)=la
		      LabelInt(la2)=la
		      Label2(icolumn)=la
		    endif
		  endif
		endif		   
	      endif
	      l2=Label2(icolumn)
	      Ia(l2)=Ia(l2)+1
	      PixVal=ImageIn(Icolumn,Iline)-Threshold
	      Sd(l2)=Sd(l2)+PixVal
	      sd2(l2)=sd2(l2)+Pixval*Pixval
	      Sd3(l2)=Sd3(l2)+Pixval*Pixval*Pixval
	      Sd4(l2)=Sd4(l2)+Pixval*Pixval*Pival*Pixal
	      Dmax(l2)=amax1(dmax(l2),Pixval)
	    endif
	  enddo
	  if(nfieldsi.ne.0) then
	  do ifield=1,Nfieldsi
	    Labelflag(ifield)=0
	    Call descen(LabelInt,Ifield,Jfield)
	    If(Ifield.ne.Jfield) then
	      Sd(jfield)=Sd(jfield)+Sd(Ifield)
	      Sd2(jfield)=Sd2(jfield)+sd2(Ifield)
	      Sd3(jfield)=Sd3(jfield)+Sd3(Ifield)
	      Ia(jfield)=Ia(jfield)+Ia(ifield)
	      Sd4(jfield)=Sd4(jfield)+sd4(Ifield)
	      Dmax(jfield)=Amax1(Dmax(jfield),Dmax(ifield))
	    endif
	  enddo
	  do icolumn=1,ncolumns
	    l2=label2(icolumn)
	    if(l2.ne.0) then
	      Call Descen(LabelInt,l2,Jfield)
	      LabelFlag(Jfield)=1
	    endif
	  enddo
	  Nfieldso=0
	  Do Ifieldi=1,Nfieldsi
	    If(Ifieldi.eq.LabelInt(Ifieldi)) then
	      If(LabelFlag(Ifieldi).ne.1.or.Iline.eq.Nlines) then
		Nfields=Nfields+1
		PixMean(Nfields)=Sd(Ifieldi)/Ia(Ifieldi)
		Npixels(Nfields)=Ia(Ifieldi)
	        PixMax(Nfields)=Dmax(Ifieldi)
		a=Pixmean(Nfields)
		b=Sd2(Ifieldi)/Ia(Ifieldi)-a*a
		if(b.lt.0.) b=0.
		b=sqrt(b)
		PixSig(Nfields)=b
		If(b.ne.0.) then
		c=(sd3(Ifieldi)-3.*a*Sd2(Ifieldi)+3.*a*a*Sd(Ifieldi))
	1         /Ia(ifieldi)-a*a*a
		PixS(Nfields)=c/(b*b*b)
	        d=(Sd4(Ifieldi)-4.*a*Sd3(Ifieldi)+6.*a*a*Sd2(Ifieldi)-
	1	  -4.*a*a*a*Sd(Ifieldi))/Ia(Ifieldi)+a*a*a*a
		PixC(Nfields)=d/(b*b*b*b)
		endif
	      else
		Nfieldso=Nfieldso+1
		LabelFin(Ifieldi)=Nfieldso
		Ia(Nfieldso)=Ia(Ifieldi)
		Sd(Nfieldso)=Sd(Ifieldi)
		Sd2(Nfieldso)=Sd2(Ifieldi)
		Sd3(Nfieldso)=Sd3(Ifieldi)
		Sd4(Nfieldso)=Sd4(Ifieldi)
		Dmax(Nfieldso)=Dmax(Ifieldi)
	      endif
	    endif
	  enddo
	  endif
	  do icolumn=1,Ncolumns
	    l2=Label2(icolumn)
	    If(l2.eq.0) then
	      Label1(icolumn)=0
	    else
	      call descen(LabelInt,l2,jfield)
	      Label1(icolumn)=LabelFin(jfield)
	    endif
	  enddo
	  if(Nfieldso.ne.0) then
	    Do Ifield=1,Nfieldso
	      LabelInt(Ifield)=Ifield
	    enddo
	  endif
	  Nfieldsi=Nfieldso
	enddo
	return
	end
	subroutine descen(label,labin,labout)
	integer*4 label(1)
	labout=labin
1	lab=label(labout)
	if(lab.eq.labout) return
	labout=lab
	goto 1
	end
