c--------------------------------------------------------------------------
c	a.bijaoui 85/1 Observatoire de Nice
c	Saidi11 allows to extract fields parameters using an image
c	segmentation by density thresholding
c	Position and pixel value of the maxima in the field
	Subroutine SaiDi11(ImageIn, Ncolumns, Nlines, Threshold,  Label1, 
	1 Label2, Nfieldsmax, LabelInt, LabelFin, Labelflag, NfieldsInt,
	2 Nfields, Pixmax, MaxColumn, Maxline, Dm, Mc, Ml)
c	ImageIn         = Image Initiale a segmenter
c	Ncolumns        = Nombre de colonnes de cette image
c	Nlines          = Nombre de lignes de cette image
c	Threshold	= Seuil de flux pour la segmentation
c	Label1		= labels of a line
c	Label2		= labels for the following line
c	Nfieldsmax	= Maximum number of fields
c	LabelInt	= Tableau 1d contenant pour chaque domaine l'etiquette
c			  Intermediaire associee
c	LabelFin	= Tableau 1d contenant pour chaque domaine l'etiquette
c			  Finale associee
c	LabelFlag	= array to determine if a field is closed
c	NfieldsInt	= Dimension maximum des Tableaux LabelInt,LabelFin
c		is Ncolumns/2 
c	Nfields         = Nombre de domaines etiquettes
c	PixMax		= maximum value of the pixel value in a field
c	MaxColumn	= Corresponding column
c	MaxLine		= Corresponding line
c	Dm		= Intermediate array
c	Mc		= ------------------
c	Ml		= ------------------
	Real*4 ImageIn(Ncolumns,Nlines), Pixmax(Nfieldsmax), Dm(NfieldsInt)
	Integer*4 LabelInt(NfieldsInt), LabelFin(NfieldsInt),
	1 Labelflag(NfieldsInt), Mc(NfieldsInt), Ml(NfieldsInt),
	2 Label1(Ncolumns), Label2(Ncolumns), MaxColumn(NfieldsMax),
	3 MaxLine(NfieldsMax)
	Nfieldsi=0
	Nfields=0
	Do icolumn=1,Ncolumns
	  Label1(icolumn)=0
	Enddo
	Do iline=1,Nlines
	  Do icolumn=1,Ncolumns
	    if(ImageIn(icolumn,Iline).lt.threshold) then
	      Label2(Icolumn)=0
	    else
	      If(Icolumn.ne.1) then
	        l1=Label2(icolumn-1)
		If(l1.ne.0) Label2(icolumn)=l1
	      endif
	      if(iline.ne.1) then
		l2=Label1(icolumn)
		if(l1.eq.0) then
		  if(l2.eq.0) then
		     Nfieldsi=Nfieldsi+1
		     LabelInt(Nfieldsi)=Nfieldsi
		     Mc(Nfieldsi)=Icolumn
		     Ml(Nfieldsi)=Iline
		     Dm(Nfieldsi)=ImageIn(Icolumn,Iline)
		     Label2(icolumn)=Nfieldsi
	          else
	             Label2(icolumn)=l2
		  endif
		else
		  if(l2.ne.0) then
		    if(l2.ne.l1) then
		      call descen(LabelInt,l1,la1)
		      call descen(LabelInt,l2,la2)
		      la=min0(la1,la2)
		      LabelInt(la1)=la
		      LabelInt(la2)=la
		      Label2(icolumn)=la
		    endif
		  endif
		endif		   
	      endif
	      l2=Label2(icolumn)
	      Pixval=ImageIn(icolumn,Iline)
	      If(Pixval.gt.Dm(l2)) then
	        Dm(l2)=Pixval
		Mc(l2)=Icolumn
		Ml(l2)=Iline
	      endif
	    endif
	  enddo
	  if(nfieldsi.ne.0) then
	  do ifield=1,Nfieldsi
	    Labelflag(ifield)=0
	    Call descen(LabelInt,Ifield,Jfield)
	    If(Ifield.ne.Jfield) then
	      if(Dm(ifield).gt.Dm(jfield)) then
		Dm(jfield)=Dm(ifield)
	 	Mc(jfield)=Mc(ifield)
		Ml(jfield)=Ml(ifield)
	      endif
	    endif
	  enddo
	  do icolumn=1,ncolumns
	    l2=label2(icolumn)
	    if(l2.ne.0) then
	      Call Descen(LabelInt,l2,Jfield)
	      LabelFlag(Jfield)=1
	    endif
	  enddo
	  Nfieldso=0
	  Do Ifieldi=1,Nfieldsi
	    If(Ifieldi.eq.LabelInt(Ifieldi)) then
	      If(LabelFlag(Ifieldi).ne.1.or.Iline.eq.Nlines) then
		Nfields=Nfields+1
		PixMax(Nfields)=Dm(Ifieldi)
		MaxColumn(Nfields)=Mc(Ifieldi)
		MaxLine(Nfields)=Ml(Ifieldi)
		if(Nfields.eq.NfieldsMax) then
		  Type 100
100	format(' You have too much output fields - Reserve more place')
		Return
		endif
	      else
		Nfieldso=Nfieldso+1
		LabelFin(Ifieldi)=Nfieldso
		Dm(Nfieldso)=Dm(Ifieldi)
		Mc(Nfieldso)=Mc(Ifieldi)
		Ml(Nfieldso)=Ml(Ifieldi)
	      endif
	    endif
	  enddo
	  endif
	  do icolumn=1,Ncolumns
	    l2=Label2(icolumn)
	    If(l2.eq.0) then
	      Label1(icolumn)=0
	    else
	      call descen(LabelInt,l2,jfield)
	      Label1(icolumn)=LabelFin(jfield)
	    endif
	  enddo
	  if(Nfieldso.ne.0) then
	    Do Ifield=1,Nfieldso
	      LabelInt(Ifield)=Ifield
	    enddo
	  endif
	  Nfieldsi=Nfieldso
	enddo
	return
	end
	subroutine descen(label,labin,labout)
	integer*4 label(1)
	labout=labin
1	lab=label(labout)
	if(lab.eq.labout) return
	labout=lab
	goto 1
	end
