c--------------------------------------------------------------------------
c	A.Bijaoui M.Khouchane E.Slezak 14 janvier 1985
c	Saidi14 permet de determiner les parametres structuraux elementaires
c	d'un domaine image
	Subroutine saidi14( ImageIn, Ncolumns, Nlines, LabelIn, Labelfield,
	2 Npixels, Flux, Xbarycenter, Ybarycenter,
	3 Majoraxis, MinorAxis, Orientation, Ierr)
	Real*4 Majoraxis, MinorAxis, ImageIn(Ncolumns,Nlines)
	Integer*4 Labelin(ncolumns,Nlines)
	double precision Xbary, Ybary, X1, Y1, X2, y2, Xy
c	ImageIn		= Original Image
c	Ncolumns	= Image Number of columns
c	Nlines		= Image Number of lines
c	LabelIn		= Labels table of the image
c	Labelfield	= Field index
c	Npixels		= Number of pixels of the field
c	Flux		= Integrate intensity of the field
c	Xbarycenter	= Field X position (weighted by intensity) in pixels
c	Ybarycenter	= Field Y position (---------------------) in pixels
c	MajorAxis	= Equivalent Major axis of the contour
c	MinorAxis	= Equivalent Minor Axis of the contour
c	Orientation	= Orientation of the ellipsis fitted to the contour
c	Ierr		= Output error parameter
c	0 no error
c	1 pixel not in a field
c	2 Field touching the frame
	Ierr=0
	If(labelField.eq.0) then
		Ierr=1
		return
	endif
	Npixels=0
	Flux=0.
	Xbary=0.
	Ybary=0.
	X1=0.
	X2=0.
	Y1=0.
	Y2=0.
	XY=0.
	IcolumnMin=Ncolumns+1
	IcolumnMax=0
	IlineMin=Nlines+1
	IlineMax=0
	do iline=1,nlines
	  y=iline
	  do icolumn=1,ncolumns
	    x=icolumn
	    If(labelField.eq.LabelIn(Icolumn,Iline)) then
	      Npixels=Npixels+1
	      Flux=Flux+ImageIn(Icolumn,Iline)
	      Xbary=Xbary+ImageIn(icolumn,Iline)*x
	      Ybary=Ybary+ImageIn(icolumn,iline)*y
	      X1=X1+x
	      Y1=Y1+y
	      X2=X2+x*x
	      Y2=Y2+y*y
	      XY=XY+x*y
	      IcolumnMin=Min0(IcolumnMin,Icolumn)
	      IcolumnMax=Max0(IcolumnMax,Icolumn)
	      IlineMin=Min0(IlineMin,Iline)
	      IlineMax=Max0(IlineMax,Iline)
	    endif
	   enddo
	enddo
	If(IcolumnMin.eq.1.or.IcolumnMax.eq.Ncolumns.Or.IlineMin.eq.1.Or.
	1 IlineMax.eq.Nlines) then
	  Ierr=2
	endif
	Xbarycenter=Xbary/Flux
	Ybarycenter=Ybary/Flux
	X1=X1/Npixels
	Y1=Y1/Npixels
	X2=x2-x1*x1*Npixels
	Y2=Y2-Y1*y1*Npixels
	XY=XY-x1*y1*Npixels
	If(x2.ne.y2) then
	  Orientation=Atan(2.*XY/(Y2-X2))/2.
	else
	  Orientation=0.7854
	endif
	S=Sin(Orientation)
	C=Cos(Orientation)
	X=C*C*X2-2.*S*C*XY+S*S*Y2
	Y2=S*S*X2+2.*S*C*XY+C*C*Y2
	X2=x
	el=Sqrt(X2/Y2)
	ss=2.*sqrt(3.14159*sqrt(x2*y2))
	Bx=Sqrt((2./El)*sqrt(sqrt(X2*Y2)/3.14159))
	Ax=Bx*El
	If(el.lt.1.) then
	  B=Ax
	  Ax=Bx
	  Bx=B
	  Orientation=Orientation+1.57079
	endif
	Orientation=360-180.*Orientation/3.14159
	MajorAxis=Ax
	MinorAxis=Bx
	Return
	End

