c******************************************************************************
c	A.Bijaoui Observatoire de Nice Octobre 1984
c	SAIDI4  Extrait le contour des objets
c	Adaptation en Fortran VMs du programme TRACER Th.Pavlidis
c  Algorithms for Graphics and Image Processing Springer-Verlag Berlin 1982
c	p.143
	Subroutine SaiDi4(LabelIn, Ncolumns, Nlines, Field, Contour, Ncontour,
	1 Icolumnd, Ilined)
c	LabelIn		Table 2d des domaines etiquettes
c	Ncolumns	Nombre de colonnes de cette table
c	Nlines		Nombre de lignes de cette table
c	Field		Domaine dont veut le contour
c	Contour		Sequence de codes de freeman decrivant le contour
c	Ncontour	Nombre de pixels du contour
c	Icolumnd	Point de depart du contour
c	Ilined		Line de depart du contour
	Integer*4  LabelIn(Ncolumns,Nlines),Field,Search,Trial
	Byte  Contour(1)
	logical*1 found, found1, found2
	Do iline=1,Nlines
	  Do icolumn=1,Ncolumns
	    If(LabelIn(Icolumn,Iline).eq.Field) then
	      If(Icolumn.eq.1) then
	        Icolumnd=Icolumn
		Ilined=Iline
		Goto 100
	      else
		If(LabelIn(icolumn-1,Iline).ne.Field) then
		  Icolumnd=Icolumn
		  Ilined=Iline
		  Goto 100
		endif
	      endif
	    endif
	  Enddo
	Enddo
	type 117
117	format( ' Domaine non trouve')
	return
100	Continue
	Search=6
	Ncontour=0
	Icolumnc=Icolumnd
	Ilinec=Ilined
110	trial=1
115	If(trial.eq.5) then
	  Type 600
600	  Format(' Domaine forme d''un point unique')	
	  return
	endif
	Call Neighbor(LabelIn,Ncolumns,Nlines,Icolumnc,Ilinec,Field,Search-1,
	1 Jcolumn,Jline,found)
	if(found) then
	  Ncontour=Ncontour+1
	  Contour(Ncontour)=Mod(Search+7,8)
	  Search=Mod(Search+6,8)
	else
	  Call Neighbor(LabelIn,Ncolumns,Nlines,Icolumnc,Ilinec,Field,Search,
	1 Jcolumn,Jline,found1)
	  If(found1) then
	    Ncontour=Ncontour+1
	    Contour(Ncontour)=Search
	  else
	    Call Neighbor(LabelIn,Ncolumns,Nlines,Icolumnc,Ilinec,Field,
	1 Search+1, Jcolumn,Jline,found2)
	    If(found2) then
	      Ncontour=Ncontour+1
	      Contour(Ncontour)=Search+1
	    else
	      Search=Mod(Search+2,8)
	      trial=trial+1
	    endif
	  endif
	endif
	if(found.or.found1.or.found2) then
	  If(Jcolumn.eq.Icolumnd.and.Jline.eq.Ilined) then
	    type 610
610	    format(' Contour termine')
	    return
	  else
	    Icolumnc=Jcolumn
	    Ilinec=Jline
	    goto 110
	  endif
	else
	  goto 115
	endif
	end
	subroutine Neighbor(LabelIn,Ncolumns,Nlines,Icolumn,Iline,Field,Search,
	1 Jcolumn,Jline,found)
	Integer*4 LabelIn(Ncolumns,Nlines),Search,Searchmod,Field
	Logical*1 found
	Integer*4 Dcolumn(8),Dline(8)
	Data Dcolumn/1,1,0,-1,-1,-1,0,1/
	Data Dline/0,-1,-1,-1,0,1,1,1/
	SearchMod=Mod(Search+8,8)+1
	Jcolumn=Icolumn+Dcolumn(SearchMod)
	Jline=Iline+Dline(SearchMod)
	found=.false.
	if(Jcolumn.lt.1.or.Jcolumn.gt.Ncolumns) return
	If(Jline.lt.1.or.Jline.gt.Nlines) return
	If(LabelIn(Jcolumn,Jline).eq.Field) found=.true.
	return
	end
