c--------------------------------------------------------------------------
c	a.bijaoui 85/1 Observatoire de Nice
c	Saidi7 allows to extract fields parameters using an image
c	segmentation by density thresholding
c	Frame coordinates min and max in x and y
	Subroutine SaiDi7(ImageIn, Ncolumns, Nlines, Threshold,  Label1, 
	1 Label2, Nfieldsmax, LabelInt, LabelFin, Labelflag, NfieldsInt,
	2 Nfields, FcolumnMin, FcolumnMax, FLineMin, FlineMax, Ici, Ica,
	3 Ili, Ila)
c	ImageIn         = Image Initiale a segmenter
c	Ncolumns        = Nombre de colonnes de cette image
c	Nlines          = Nombre de lignes de cette image
c	Threshold	= Seuil de flux pour la segmentation
c	Label1		= labels of a line
c	Label2		= labels for the following line
c	Nfieldsmax	= Maximum number of fields
c	LabelInt	= Tableau 1d contenant pour chaque domaine l'etiquette
c			  Intermediaire associee
c	LabelFin	= Tableau 1d contenant pour chaque domaine l'etiquette
c			  Finale associee
c	LabelFlag	= array to determine if a field is closed
c	NfieldsInt	= Dimension maximum des Tableaux LabelInt,LabelFin
c		is Ncolumns/2 
c	Nfields         = Nombre de domaines etiquettes
c	FColumnMIn	= Minimum column of a field
c	FcolumnMax	= Corresponding max column
c	FlineMin	= ------------- Min line
c	FlineMax	= ------------- Max line
c	Ici		= Intermediate array for min column
c	Ica		= ---------------------- max column
c	Ili		= ---------------------- min line
c	Ila		= ---------------------- max line
	Real*4 ImageIn(Ncolumns,Nlines)
	Integer*4 LabelInt(NfieldsInt), LabelFin(NfieldsInt),
	1 Labelflag(NfieldsInt), Label1(Ncolumns),
	2 Label2(Ncolumns), FColumnMin(NfieldsMax), FColumnMax(Nfieldsmax),
	3 FlineMin(NfieldsMax), FlineMax(NfieldsMax), Ici(NfieldsInt),
	4 Ica(NfieldsInt), Ili(NfieldsInt), Ila(NfieldsInt)
	Nfieldsi=0
	Nfields=0
	Do icolumn=1,Ncolumns
	  Label1(icolumn)=0
	Enddo
	Do iline=1,Nlines
	  Do icolumn=1,Ncolumns
	    if(ImageIn(icolumn,Iline).lt.threshold) then
	      Label2(Icolumn)=0
	    else
	      If(Icolumn.ne.1) then
	        l1=Label2(icolumn-1)
		If(l1.ne.0) Label2(icolumn)=l1
	      endif
	      if(iline.ne.1) then
		l2=Label1(icolumn)
		if(l1.eq.0) then
		  if(l2.eq.0) then
		     Nfieldsi=Nfieldsi+1
		     LabelInt(Nfieldsi)=Nfieldsi
		     Ici(Nfieldsi)=Icolumn
		     Ica(Nfieldsi)=Icolumn
		     Ili(Nfieldsi)=Iline
		     Ila(Nfieldsi)=Iline
		     Label2(icolumn)=Nfieldsi
	          else
	             Label2(icolumn)=l2
		  endif
		else
		  if(l2.ne.0) then
		    if(l2.ne.l1) then
		      call descen(LabelInt,l1,la1)
		      call descen(LabelInt,l2,la2)
		      la=min0(la1,la2)
		      LabelInt(la1)=la
		      LabelInt(la2)=la
		      Label2(icolumn)=la
		    endif
		  endif
		endif		   
	      endif
	      l2=Label2(icolumn)
	      Ici(l2)=Min0(Ici(l2),Icolumn)
	      Ica(l2)=Max0(Ica(l2),Icolumn)
	      Ili(l2)=Min0(Ili(l2),Iline)
	      Ila(l2)=Max0(Ila(l2),Iline)
	    endif
	  enddo
	  if(nfieldsi.ne.0) then
	  do ifield=1,Nfieldsi
	    Labelflag(ifield)=0
	    Call descen(LabelInt,Ifield,Jfield)
	    If(Ifield.ne.Jfield) then
	      Ici(Jfield)=Min0(Ici(jfield),Ici(Ifield))
	      Ica(Jfield)=Max0(Ica(jfield),Ica(Ifield))
	      Ili(Jfield)=Min0(Ili(jfield),Ili(Ifield))
	      Ila(Jfield)=Max0(Ila(jfield),Ila(Ifield))
	    endif
	  enddo
	  do icolumn=1,ncolumns
	    l2=label2(icolumn)
	    if(l2.ne.0) then
	      Call Descen(LabelInt,l2,Jfield)
	      LabelFlag(Jfield)=1
	    endif
	  enddo
	  Nfieldso=0
	  Do Ifieldi=1,Nfieldsi
	    If(Ifieldi.eq.LabelInt(Ifieldi)) then
	      If(LabelFlag(Ifieldi).ne.1.or.Iline.eq.Nlines) then
		Nfields=Nfields+1
		FcolumnMin(Nfields)=Ici(Ifieldi)
		FcolumnMax(Nfields)=Ica(Ifieldi)
		FlineMin(Nfields)=Ili(Ifieldi)
		FlineMax(Nfields)=Ila(Ifieldi)
		if(Nfields.eq.NfieldsMax) then
		  Type 100
100	format(' You too much output fields - Reserve more place')
		Return
		endif
	      else
		Nfieldso=Nfieldso+1
		LabelFin(Ifieldi)=Nfieldso
		Ici(Nfieldso)=Ici(Ifieldi)
		Ica(Nfieldso)=Ica(Ifieldi)
		Ili(Nfieldso)=Ili(Ifieldi)
		Ila(Nfieldso)=Ila(Ifieldi)
	      endif
	    endif
	  enddo
	  endif
	  do icolumn=1,Ncolumns
	    l2=Label2(icolumn)
	    If(l2.eq.0) then
	      Label1(icolumn)=0
	    else
	      call descen(LabelInt,l2,jfield)
	      Label1(icolumn)=LabelFin(jfield)
	    endif
	  enddo
	  if(Nfieldso.ne.0) then
	    Do Ifield=1,Nfieldso
	      LabelInt(Ifield)=Ifield
	    enddo
	  endif
	  Nfieldsi=Nfieldso
	enddo
	return
	end
	subroutine descen(label,labin,labout)
	integer*4 label(1)
	labout=labin
1	lab=label(labout)
	if(lab.eq.labout) return
	labout=lab
	goto 1
	end
