c------------------------------------------------------------------------------
c	a.bijaoui Observatoire de Nice Octobre 1984
c	Saifi13 tabule des coefficients de lissage 2d particuliers
	Subroutine SaiFi13(Table,option)
c	Table	= Tableau 2d des coefficients
c	Option  = Option choisie :
c	1	: Moyenne simple
c	2	: Gradient x
c	3	: Gradient y
c	4	: Laplacien
c	5	: Difference 2 en x
c	6	: Difference 2 en y
c	7	: Difference en x y
c	8	: Lissage polynomiale homogene
	Real*4 Table(9)
	Integer*4 Option
	If(option.lt.1.or.option.gt.8) then
	  type 100
100	  format(' Option inexistante')
	  stop
	endif
	Goto(101,102,103,104,105,106,107,108),option
101	a=1/9.
	do i=1,9
	  Table(i)=a
	enddo
	return
102	a=1./6.
	do iy=1,3
	    i=3*(iy-1)+1
	    Table(i)=-a
	    Table(i+1)=0.
	    Table(i+2)=a
	enddo
	return
103	a=1./6.
	do ix=1,3
	    Table(ix)=-a
	    Table(ix+3)=0.
	    Table(ix+6)=a
	enddo
	return
104	a=1./3.
	Table(1)=2*a
	Table(2)=-a
	Table(3)=2*a
	Table(4)=-a
	Table(5)=-4*a
	Table(6)=-a
	Table(7)=2*a
	Table(8)=-a
	Table(9)=2*a
	return
105	a=1./3.
	do iy=1,3
	  i=3*iy-2
	  Table(i)=a
	  Table(i+1)=-2.*a
	  Table(i+2)=a
	enddo
	return
106	a=1./3.
	do ix=1,3
	  Table(ix)=a
	  Table(ix+3)=-2.*a
	  Table(ix+6)=a
	enddo
	return
107	a=1./4.
	Table(1)=a
	Table(2)=0.
	Table(3)=-a
	Table(4)=0.
	Table(5)=0.
	Table(6)=0.
	Table(7)=-a
	Table(8)=0.
	Table(9)=a
	return
108	a=1./9.
	Table(1)=-a
	Table(2)=2.*a
	Table(3)=-a
	Table(4)=2.*a
	Table(5)=5.*a
	Table(6)=2.*a
	Table(7)=-a
	Table(8)=2.*a
	Table(9)=-a
	return
	end
