c.ps 60,68
c.hl 1 Smoothing coefficients from a local trigonometric basis
c.x SAIFI17
c.x Smoothing > trigonometric basis
c.nf.ts 14,32
cA.Bijaoui	85/4	Nice Observatory
c.f
c.ap ! But, Methode et Algorithme
c	Allows to compute the smoothing coefficients determined using a
clocal approximation using a trigonometric basis.
c.b.c; ^&Call and Parameters\&
c.b;CALL SAIFI17(Table, Ntable, Nharm)
c.b
c.nf.ts 14,27,30
cTable	R*4(Ntable)	O	Resulting coefficients array
cNtable	I*4	I	Number of coefficients
c			1/2 window+1
cNharm	I*4	I	Number of used harmonics
c.f
	Subroutine SaiFi17(Table,Ntable,Nharm)
	Real*4 Table(Ntable)
	Nw=Ntable-1
	Nt=Nw+Ntable
	Q=1./Nt
	Do Itable=1,Ntable
	  Table(Itable)=Q
	Enddo
	If(Nharm.le.0) return
	Nharm=Min0(Nharm,Nw)
	Q=2.*Q
	Alpha=Q*3.14159
	Do Iharm=1,Nharm
	  Do Itable=1,Ntable
	    Table(Itable)=Table(Itable)+Q*cos(Alpha*float((ITable-1)*Iharm))
	  Enddo
	Enddo
	Return
	End
