c.ps 60,68
c.hl 1 Smoothing coefficients for a deconvolution with a local 
ctrigonometric basis
c.x SAIFI18
c.x Deconvolution> trigonometric basis
c.nf.ts 14,32
cA.Bijaoui	85/4	Nice Observatory
c.f
c.ap ! But, Methode et Algorithme
c	Allows to compute the coefficients for deconvolution 
cdetermined using a
clocal approximation using a trigonometric basis.
c.p;The point spread function is gaussian.
c.b.c; ^&Call and Parameters\&
c.b;CALL SAIFI18(Table, Ntable, Nharm, Sigma)
c.b
c.nf.ts 14,27,30
cTable	R*4(Ntable)	O	Resulting coefficients array
cNtable	I*4	I	Number of coefficients
c			1/2 window+1
cNharm	I*4	I	Number of used harmonics
cSigma	R*4	I	Sigma of the gaussian PSF, in pixels
c.f
	Subroutine SaiFi18(Table,Ntable,Nharm,Sigma)
	Real*4 Table(Ntable)
	PI=3.1415919
	Nw=Ntable-1
	Nt=Nw+Ntable
	Q=1./Nt
	v=2.*pi*pi*sigma*sigma/float(nt*nt)
	Do Itable=1,Ntable
	  Table(Itable)=Q
	Enddo
	If(Nharm.le.0) return
	Nharm=Min0(Nharm,Nw)
	Q=2.*Q
	Alpha=Q*pi
	Do Iharm=1,Nharm
	  w=exp(v*float(iharm*iharm))
	  Do Itable=1,Ntable
	    Table(Itable)=Table(Itable)+w*Q*cos(Alpha*float((ITable-1)
	1 *Iharm))
	  Enddo
	Enddo
	Return
	End
