c.ps 60,68
c.hl 1 Noise Cheating Enhancement
c.x SAIFI9
c.x Noise reduction> Noise Cheating
c.nf.ts 14,32
cA.Bijaoui	85/3	Nice Observatory
c.f
c.ap
c	Allows to reduce the noise by the " Noise Cheating Enhancement "
ctechnic, developped by Zweig and Barnett (J. opt. Soc. Am. 1976)
c	We define a threshold for a integration flux. For each image pixel we
cintegrate in a square field up to obtain a flux greater than the threshold. The
coutput pixel value is the ratio of the integrate flux on the number of pixels
cused for integration.
c	This noise reduction is very suitable for photon counting systems, or
cfor detection of faint features in the wings of galaxies, nebulous, comets..
c.b.c; ^&Call and Parameters\&
c.b;CALL SAIFI9(ImageIn, Ncolumns, Nlines, ImageOut, Flux)
c.b
c.nf.ts 14,27,30
cImageIn	R*4(Ncolumns,Nlines)	I	Image to process
cNcolumns	I*4	I	Corresponding number of columns
cNlines	I*4	I	Corresponding number of lines
cImageOut	R*4(Ncolumns,Nlines)	O	Resulting image
cFlux	R*4	I	Flux Threshold
c.f
	Subroutine SAIFI9(ImageIn, Ncolumns, Nlines, ImageOut, Flux)
	Real*4 ImageIn(Ncolumns,Nlines),ImageOut(Ncolumns,Nlines)
	Do Iline=1,Nlines
	  Do Icolumn=1,Ncolumns
	    K=0
	    X=ImageIn(Icolumn,Iline)
100	Continue
	    If(X.Lt.Flux) then
	      K=K+1
	      Il1=Max0(1,Iline-k)
	      Il2=Min0(Nlines,Iline+k)
	      Ic1=Icolumn-k
	      Ic2=Icolumn+k
	      Do Ic=Ic1,Ic2
		Ic3=Max0(1,Ic)
		Ic3=Min0(Ncolumns,Ic3)
		x=x+ImageIn(Ic3,Il1)+ImageIn(Ic3,Il2)
	      Enddo
	      Il1=Iline-k+1
	      Il2=Iline+k-1
	      Ic1=Max0(1,Ic1)
	      Ic2=Min0(Ncolumns,Ic2)
	      Do Il=Il1,Il2
		Il3=Max0(1,Il)
		Il3=Min0(Nlines,Il3)
		x=x+ImageIn(Ic1,Il3)+ImageIn(Ic2,Il3)
	      Enddo
	      Goto 100
	    Endif
	    ImageOut(Icolumn,Iline)=X/Float((2*k+1)**2)
	  Enddo
	Enddo
	Return
	End

