c	A.Bijaoui 85/1 Nice Observatory
c	saigi2 allows to determine the pixel value for a point
	Subroutine SaiGi2(ImageIn,Ncolumns,Nlines,Startx,Starty,Stepx,
	1 Stepy,xval,yval,pixval,Icolumn,EpsColumn,Iline,EpsLine,Option,Ierr)
c	ImageIn		Working Image
c	Ncolumns	Corresponding number of columns
c	Nlines		----------------------- lines
c	Startx		------------- starting x
c	Starty		------------- -------- y
c	Stepx		------------- step in x
c	Stepy		--------------------- y
c	Xval		x of the studied point
c	Yval		y --------------------
c	Pixval		Resulting pixel value
c	Icolumn		Image column of this point
c	Iline		------ line --------------
c	Epscolumn	Difference between real column and integer one
c	EpsLine		------------------------ line ----------------
c	Option		Working option
c	0	Near neighbour
c	1	Linear interpolation
c	Ierr		Error parameter
c	0	no error
c	1	Point outside the image field: value 0 given
	Real*4 ImageIn(Ncolumns,Nlines), Line
	Integer*4 Option
	Column=(Xval-Startx)/stepx+1.
	Line=(Yval-Starty)/stepy+1.
	If(Option.eq.0) then
	  Icolumn=Ifix(Column+0.5)
	  Iline=Ifix(Line+0.5)
	  EpsColumn=0.
	  Epsline=0.
	  If(Icolumn.lt.1.Or.Icolumn.gt.Ncolumns) then
	    Ierr=1
	    Pixval=0.
	    Return
	  endif
	  If(Iline.lt.1.Or.Iline.gt.Nlines) then
	    Ierr=1
	    Pixval=0.
	    Return
	  endif
	  Pixval=ImageIn(Icolumn,Iline)
	  Return
	else
	  Icolumn=Column
	  Iline=Line
	  EpsColumn=0.
	  Epsline=0.
	  If(Icolumn.lt.1.Or.Icolumn.gt.Ncolumns) then
	    Ierr=1
	    Pixval=0.
	    Return
	  endif
	  If(Iline.lt.1.Or.Iline.gt.Nlines) then
	    Ierr=1
	    Pixval=0.
	    Return
	  endif
	  EpsColumn=Column-Icolumn
	  Epsline=Line-Iline
	endif
	Pixval=ImageIn(Icolumn,Iline)
	If(Epscolumn.ne.0.) then
	  Pixval=Pixval+Epscolumn*(ImageIn(Icolumn+1,iline)-
	1        ImageIn(Icolumn,Iline))
	endif
	If(Epsline.ne.0.) then
	  Pixval= Pixval+EpsLine*(ImageIn(Icolumn,Iline+1)-
	2         ImageIn(Icolumn,Iline))
	  If(EpsColumn.ne.0.) then
	    PixVal=Pixval+EpsLine*EpsColumn*(ImageIn(Icolumn+1,Iline+1)-
	1          ImageIn(Icolumn+1,Iline)-ImageIn(Icolumn,Iline+1)
	2          +ImageIn(Icolumn,Iline))
	  endif
	endif
	Return
	end
