c	A.Bijaoui 85/1 Nice Observatory
c	saigi3 allows to determine the pixel value for a point on a line
	Subroutine SaiGi3(ImageIn,Ncolumns,Nlines,Startx,Stepx,
	1 xval,Iline,pixval,Icolumn,EpsColumn,Option,Ierr)
c	ImageIn		Working Image
c	Ncolumns	Corresponding number of columns
c	Nlines		----------------------- lines
c	Startx		------------- starting x
c	Stepx		------------- step in x
c	Xval		x of the studied point
c	Iline		Corresponding image line
c	Pixval		Resulting pixel value
c	Icolumn		Image column of this point
c	Epscolumn	Difference between real column and integer one
c	Option		Working option
c	0	Near neighbour
c	1	Linear interpolation
c	2	Pseudo spine Interpolation (degree 3)
c	3	-----------------------------------5-
c	4	B spline approximation (degree 3)
c	Ierr		Error parameter
c	0	no error
c	1	Point outside the image field: value 0 given
	Real*4 ImageIn(Ncolumns,Nlines)
	Integer*4 Option
	External PS3,PS5,BS3
	Column=(Xval-Startx)/stepx+1.
	Ierr=0
	If(Option.eq.0) then
	  Icolumn=Ifix(Column+0.5)
	  EpsColumn=0.
	  If(Icolumn.lt.Ncolumn.Or.Icolumn.Gt.Ncolumns) Ierr=1
	  If(ierr.eq.1) then
	    Pixval=0.
	    Return
	  endif
	  Pixval=ImageIn(Icolumn,Iline)
	  Return
	else
	  Icolumn=Column
	  EpsColumn=0.
	  If(Icolumn.lt.Ncolumn.Or.Icolumn.Gt.Ncolumns) Ierr=1
	  If(ierr.eq.1) then
	    Pixval=0.
	    Return
	  endif
	  EpsColumn=Column-Icolumn
	endif
	goto (1,2,3,4), Option
1	Pixval=ImageIn(Icolumn,Iline)
	If(Epscolumn.ne.0.) then
	  Pixval=Pixval+Epscolumn*(ImageIn(Icolumn+1,iline)-
	1 ImageIn(Icolumn,Iline))
	endif
	Return
2	Call Inter(ImageIn(1,Iline),Ncolumns,Icolumn,EpsColumn,PS3,Pixval)
	Return
3	Call Inter(ImageIn(1,Iline),Ncolumns,Icolumn,EpsColumn,PS5,Pixval)
	Return
4	Call Inter(ImageIn(1,Iline),Ncolumns,Icolumn,EpsColumn,BS3,Pixval)
	Return
	end
	Subroutine Inter(Line,Ncolumns,Icolumn,EpsColumn,Func,Pixval)
c	Four Points Interpolation
	Real*4	Line(Ncolumns)
	External Func
	Pixval=0.
	Do K=1,4
	  I=Icolumn+K-2
	  If(I.lt.1) i=1
	  If(I.gt.Ncolumns) i=Ncolumns
	  Pixval=Pixval+Line(I)*Func(K,EpsColumn)
	Enddo
	Return
	End	
	Function PS3(K,x)
	goto (1,2,3,4),k
1	PS3=-0.5*x*(1.-x)*(1.-x)
	return
2	ps3=0.5*(1.-x)*(2.-3.*x*x+2.*x)
	return
3	ps3=0.5*x*(1.+4.*x-3.*x*x)
	return
4	ps3=-0.5*x*x*(1.-x)
	return
	end
 	FUNCTION PS5(l,x)
 	GO TO (1,2,3,4),L
 1	PS5=-0.5*X+0.5*X**2+1.5*X**3-2.5*X**4+X**5
 	GO TO 5
 2	PS5=1-X**2-4.5*X**3+7.5*X**4-3*X**5
 	GO TO 5
 3	PS5=0.5*X+0.5*X**2+4.5*X**3-7.5*X**4+3*X**5
 	GO TO 5
 4	PS5=-1.5*X**3+2.5*X**4-X**5
 5	RETURN
 	END
 	FUNCTION BS3(l,x)
 	GO TO (1,2,3,4),L
 1	BS3=((1.-X)**3)/6.
 	GO TO 5
 2	BS3=0.5*(X**3)-(X**2)+2./3.
 	GO TO 5
 3	BS3=-0.5*(X**3)+0.5*(X**2)+0.5*X+1./6.
 	GO TO 5
 4	BS3=(X**3)/6.
 5	RETURN
 	END
