c	A.Bijaoui 85/1 Nice Observatory
c	saigi4 allows to determine the pixel value for a point
c	with 2d 4 points interpolation
	Subroutine SaiGi4(ImageIn,Ncolumns,Nlines,Startx,Starty,Stepx,
	1 Stepy,xval,yval,pixval,Icolumn,EpsColumn,Iline,EpsLine,Option,Ierr)
c	ImageIn		Working Image
c	Ncolumns	Corresponding number of columns
c	Nlines		----------------------- lines
c	Startx		------------- starting x
c	Starty		------------- -------- y
c	Stepx		------------- step in x
c	Stepy		--------------------- y
c	Xval		x of the studied point
c	Yval		y --------------------
c	Pixval		Resulting pixel value
c	Icolumn		Image column of this point
c	Iline		------ line --------------
c	Epscolumn	Difference between real column and integer one
c	EpsLine		------------------------ line ----------------
c	Option		Working option
c	2	Pseudo spine Interpolation (degree 3)
c	3	-----------------------------------5-
c	4	B spline approximation (degree 3)
c	Ierr		Error parameter
c	0	no error
c	1	Point outside the image field: value 0 given
	Real*4 ImageIn(Ncolumns,Nlines), Line, Pix(4)
	Integer*4 Option
	External Ps3, Ps5, Bs3
	Ierr=0
	Line=(Yval-Starty)/stepy+1.
	Iline=Line
	Epsline=0.
	If(Iline.lt.1.Or.ILine.gt.Nlines) then
	  Ierr=1
	  Pixval=0.
	  Return
	endif
	Epsline=Line-Iline
	I=Max0(Iline-1,1)
	Call SaiGi3(ImageIn,Ncolumns,Nlines,Startx,Stepx,Xval,I,Pix(1),Icolumn,
	1 EpsColumn,Option,Ierr)
	If(Ierr.eq.1) then
	  Pixval=0.
	  Return
	endif
	Call SaiGi3(ImageIn,Ncolumns,Nlines,Startx,Stepx,Xval,Iline,Pix(2),
	1 Icolumn,EpsColumn,Option,Ierr)
	I=Min0(Iline+1,Nlines)
	Call SaiGi3(ImageIn,Ncolumns,Nlines,Startx,Stepx,Xval,I,Pix(3),Icolumn,
	1 EpsColumn,Option,Ierr)
	I=Min0(Iline+2,Nlines)
	Call SaiGi3(ImageIn,Ncolumns,Nlines,Startx,Stepx,Xval,I,Pix(4),Icolumn,
	1 EpsColumn,Option,Ierr)
	Goto(1,1,2,3)Option
1	Call Inter(Pix,4,2,Epsline,Ps3,Pixval)
	Return
2	Call Inter(Pix,4,2,Epsline,Ps5,PIxval)
	Return
3	Call Inter(Pix,4,2,Epsline,Bs3,Pixval)
	Return
	End
