c--------------------------------------------------------------------------
c	A.Bijaoui Janvier 1985
c	SaiIi1 permet d'effectuer la correlation croisee entre 2 images
	Subroutine Saiii1(ImageIn1, Npixels, ImageIn2, Option,
	1 Mean1, Mean2, Dis1, Dis2, Cor12)
c	ImageIn1	First Image
c	Npixels		Corresponding Number of pixels
c	ImageIn2	Second image (same number of columns and lines)
c	Option		Working option
c	0	crossproduct (linear discriminant analysis)
c	else	statistical correlation
c	Mean1		mean in pixel value for image 1
c	Mean2		Mean in pixel value for image 2
c	Dis1		Standard deviation for image 1
c	Dis2		Standard deviation for image 2
c	Cor12		If Option=0 Cross product Images 1*2
c			If not      Statiscal correlation 1 2
	Real*4 ImageIn1(Npixels), ImageIn2(Npixels)
	Real*4 Mean1,Mean2
	Integer*4 Option
	pixels=float(npixels)
	if(option.ne.0) then
	  Mean1=0.
	  Mean2=0.
	  Dis1=0.
	  Dis2=0.
	  do ipixel=1,npixels
	    mean1=mean1+ImageIn1(Ipixel)
	    mean2=mean2+ImageIn2(Ipixel)
	  enddo
	  mean1=mean1/pixels
	  mean2=mean2/pixels
	endif
	Cor12=0.
	do ipixel=1,Npixels
	  If(Option.eq.0) then
	    Cor12=ImageIn1(Ipixel)*ImageIn2(Ipixel)
	  else
	    x1=ImageIn1(Ipixel)-mean1
	    x2=ImageIn2(Ipixel)-Mean2
	    Dis1=X1*x1+dis1
	    dis2=x2*x2+dis2
	    cor12=cor12+x1*x2
	  endif
	enddo
	if(option.eq.0) then
	  Cor12=Cor12/pixels
	  Return
	else
	  Dis1=Sqrt(Dis1/pixels)
	  Dis2=Sqrt(Dis2/pixels)
	  Cor12=Cor12/(Pixels*Dis1*Dis2)
	  Return
	endif
	end
