c-----------------------------------------------------------------------------
c	saiii3 permet de calculer l'autocorrelation d'une portion d'image
c	a deux dimensions
c	a.bijaoui o.n. janvier 1985
	subroutine saiii4(ImageIn, Ncolumns, Nlines, FirstColumn,
	1 LastColumn, StepColumn, FirstLine, LastLine, StepLine,
	2 ImageOut, Ncor1, Ncor2, Option)
c	ImageIn		Input Image
c	Ncolumns	Corresponding number of columns
c	Nlines		Corresponding number of lines
c	FirstColumn	First Column
c	LastColumn	Last Column
c	StepClomun	Step in column
c	FirstLine	First Line
c	LastLine	Last Line
c	StepLine	Step in line
c	ImageOut	Output image containing the correlation
c	Ncor1		number of points for autocorrelation (columns)
c	Ncor2		Number of points for autocorrelation (lines)
c	Option		Working Option
c	1	cyclic autocorrelation no centered
c	2	cyclic autocorrelation centered
c	3	normal autocorrelation no centered
c	4	normal autocorrelation centered
	Real*4	ImageIn(Ncolumns,Nlines), ImageOut(ncor1,Ncor2), Mean
	Integer*4 FirstColumn, StepColumn, FirstLine, StepLine, Option
	Call tpar(FirstColumn,LastColumn,StepColumn,Ncolumns,NcolumnsOut)
	Call Tpar(FirstLine,LastLine,StepLine,Nlines,NlinesOut)
	pixels=NlinesOut*NcolumnsOut
	Mean=0.
	If(Option.eq.2.Or.Option.eq.4) then
	  Do iline=FirstLine,LastLine,StepLine
	    Do Icolumn=FirstColumn,LastColumn,StepColumn
	      Mean=Mean+ImageIn(Icolumn,Iline)
	    enddo
	  enddo
	  Mean=Mean/pixels
	Endif
	Do icor1=1,Ncor1
	  Do icor2=1,ncor2
	    ImageOut(icor2,icor1)=0.
	    npicor=0
	    Do iline=FirstLine,LastLine,StepLine
	      do icolumn=FirstColumn,LastColumn,StepColumn
	        jcolumn=icolumn+icor2-2
	        jline=iline+icor1-2
	        if(option.eq.1.or.option.eq.2) then
	          jcolumn=mod(jcolumn,ncolumns)+1
		  jline=mod(jline,nlines)+1
		  ImageOut(icor2,icor1)=ImageOut(icor2,icor1)+
	1	  (ImageIn(icolumn,iline)-mean)*
	2	  (ImageIn(jcolumn,iline)-mean)
		  npicor=npicor+1
	        else
		  if(jcolumn.lt.ncolumns.and.jline.lt.nlines) then
		    ImageOut(icor2,icor1)=ImageOut(icor2,icor1)+
	1	    (ImageIn(icolumn,iline)-mean)*
	2	    (ImageIn(jcolumn,iline)-mean)
		    npicor=npicor+1
	          endif
	        endif
	      enddo
	    enddo
	    ImageOut(icor2,icor1)=ImageOut(icor2,icor1)/Npicor
	  enddo
	enddo
	return
	end
