c---------------------------------------------------------------------
c	A.Bijaoui Nice Observatory 85/1
c	Saiii5 allows to diagonalise a correlation matrix taking
c	into account the variance
	Subroutine Saiii5(ImageIn, Ncor, Variance, NvecMax, EigenVal,
	1 EigenVec,  Image, X, Cor)
c	ImageIn		Correlation matrix
c	Ncor		Dimension of this matrix
c	Variance	Variance threshold for diagonalisation
c			at the Output residual one
c	NvecMax		Maximum Number of eigenvectors
c			at the Output real number one
c	EigenVal	Eigenvalues array
c	EigenVec	EigenVectors array
c	Image		Intermediate array for computation
c	X		Intermediate array
c	Cor		Intermediate array
	Real*4	ImageIn(Ncor,Ncor), Image(Ncor,Ncor), EigenVec(Ncor,NvecMax),
	1 EigenVal(NvecMax), X(Ncor), Cor(Ncor)
	do icor1=1,Ncor
	  do icor2=1,Ncor
	    Image(icor2,Icor1)=ImageIn(Icor2,Icor1)
	  enddo
	enddo
	do j=1,nvecmax
	IM=1
 	DO icor=2,ncor
 	  IF(Image(icor,icor).GT.Image(IM,IM)) IM=icor
	enddo
c 	Type 620,Image(Im,Im)
c 620	FORMAT(' PLUS GRAND TERME:  ',E10.3)
 	IF(Image(IM,IM).LT.Variance) then
	  Nvecmax=J-1
	  Variance=Image(Im,Im)
	  return
	endif
 	DO icor=1,ncor
 	  X(icor)=0.
 	  IF(icor.EQ.IM) X(icor)=1.
	enddo
 	COR(IM)=1.
 20	CONTINUE
 	AM=0.
 	IM=1
 	DO Icor=1,ncor
 	  AMA=ABS(X(Icor))
 	  IF(AMA.gt.AM) then
 	    AM=AMA
 	    IM=Icor
	  endif
	enddo
 	DO Icor=1,ncor
	  X(Icor)=X(Icor)/AM
	enddo
 	COR(IM)=1.
 	AL=0.
 	DO icor=1,ncor
	  AL=AL+Image(icor,IM)*X(icor)
	enddo
 	AM=0.
 	DO icor=1,ncor
 	  IF(icor.ne.IM) then
 	    S=0.
 	    DO icor1=1,ncor
	      S=S+Image(icor,icor1)*X(icor1)
	    enddo
 	    AMA=ABS((X(icor)*AL/S)-1.)
 	    IF(AMA.GT.AM) AM=AMA
 	    COR(icor)=S/AL
	  endif
	enddo
 	DO icor=1,ncor
	  X(icor)=COR(icor)
	enddo
 	IF(AM.GT.0.00001) GO TO 20
 	ANX=0.
 	DO icor=1,ncor
	  ANX=ANX+X(icor)**2
	enddo
 	ANX=SQRT(ANX)
 	DO icor=1,ncor
	  X(icor)=X(icor)/ANX
	enddo
c 	Type 505, AL
c 505	FORMAT(' VALEUR PROPRE:',E12.5)
c 	Type 507, (X(icor),icor=1,ncor)
c 507	FORMAT(1X,12E10.3)
 	EigenVal(J)=SQRT(AL)
 	DO icor1=1,ncor
 	  DO icor2=1,ncor
	    Image(icor1,icor2)=Image(icor1,icor2)-X(icor1)*X(icor2)*AL
	  enddo
	enddo
	Do icor=1,ncor
	  EigenVec(icor,j)=X(icor)
	enddo
	enddo
 	END
