c-----------------------------------------------------------------------------
c	A.Bijaoui Nice Observatory 85/1
c	SaiKi1 : Linear resampling of an image line
	Subroutine SaiKi1(ImageIn, Nci, Nli, Ili, ImageOut,
	1 Nco, Nlo, Ilo, xdi, dxi, xdo, dxo)
c	ImageIn		Working Image
c	Nci		Corresponding number of columns
c	Nli		Corresponding number of lines
c	Ili		Corresponding working line
c	ImageOut	Resulting Image
c	Nco		Corresponding number of columns
c	Nlo		Corresponding number of lines
c	Ilo		Corresponding working line
c	Xdi		Starting x for input image
c	Dxi		Sampling x step for input image
c	Xdo		Starting x for output Image
c	Dxo		Sampling x step for output image
	Real*4	ImageIn(Nci,Nli), ImageOut(Nco, Nlo)
	x=xdo
	ci=float(nci)
	Do ico=1,Nco
	  xc=(x-xdi)/dxi+1.
	  if(xc.lt.1..or.xc.gt.ci) then
	    ImageOut(ico,ilo)=0.
	  else
	    ici=xc
	    eps=xc-ici
	    ImageOut(ico,ilo)=ImageIn(ici,Ili)
	    If(eps.ne.0.) ImageOut(ico,ilo)=ImageOut(ico,Ilo)+esp*
	1     (ImageIn(ici+1,Ili)-ImageIn(Ici,Ili))
	  endif
	  x=x+dxo
	enddo
	return
	end
