c-----------------------------------------------------------------------------
c	A.Bijaoui Nice Observatory 85/1
c	SaiKi2 : Linear resampling of a whole image 
	Subroutine SaiKi2(ImageIn, Nci, Nli, ImageOut,
	1 Nco, Nlo, xdi, dxi, ydi,dyi, xdo, dxo, ydo, dyo, Line)
c	ImageIn		Working Image
c	Nci		Corresponding number of columns
c	Nli		Corresponding number of lines
c	ImageOut	Resulting Image
c	Nco		Corresponding number of columns
c	Nlo		Corresponding number of lines
c	Xdi		Starting x for input image
c	Dxi		Sampling x step for input image
c	Ydi		Starting y for input image
c	Dyi		Sampling y step for input image
c	Xdo		Starting x for output Image
c	Dxo		Sampling x step for output image
c	Ydo		Starting y for output Image
c	Dyo		Sampling y step for output image
c	Line		Intermediate resampled line
	Real*4	ImageIn(Nci,Nli), ImageOut(Nco, Nlo), Line(nco)
	y=ydo
	yli=float(nli)
	Do ilo=1,nlo
	  yl=(y-ydi)/dyi+1
	  if(yl.lt.1..or.yl.gt.yli) then
	    do ico=1,nco
	      ImageOut(ico,Ilo)=0.
	    enddo
	  else
	    Ili=yl
	    Eps=Yl-Ili
	    Call Saiki1(ImageIn,Nci,Nli,Ili,ImageOut,Nco,Nlo,Ilo,Xdi,
	1 Dxi,Xdo,Dxo)
	    If(eps.ne.0.) then
	      Call saiki1(ImageIn,Nci,Nli,Ili+1,Line,Nco,1,1,Xdi,Dxi,
	1 Xdo,Dxo)
	      Do ico=1,nco
	        ImageOut(ico,ilo)=ImageOut(ico,ilo)+eps*
	1	(Line(ico)-ImageOut(ico,ilo))
	      enddo
	    endif
	  endif
	  y=y+dyo
	enddo
	return
	end
