c-------------------------------------------------------------------------
c	A.Bijaoui Nice Observatory 85/1
c	SaiKi3 allows to do rotation , translation, magnification
	Subroutine SaiKi3(ImageIn, Nci, Nli, Xdi, Dxi, Ydi, Dyi,
	1 ImageOut, Nco, Nlo, Xdo, Dxo, Ydo, Dyo,
	2 a, b, x0, y0)
c	ImageIn		Working Image
c	Nci		Corresponding Number of columns
c	Nli		Corresponding Number of lines
c	Xdi		Corresponding starting x
c	Dxi		Corresponding x step
c	Ydi		Corresponding starting y
c	Dyi		Corresponding y step
c	ImageOut	Resulting Image
c	Nco		Corresponding Number of columns
c	Nlo		Corresponding Number of lines
c	Xdo		Corresponding starting x
c	Dxo		Corresponding x step
c	Ydo		Corresponding starting y
c	Dyo		Corresponding y step
c	The transformation is :
c	Xin = a* Xout - b* Yout + X0
c	Yin = b* Xout + a* Yout + Y0
c	Where Xin, Yin are the input coordonates of a point, and Xout, Yout
c	are the corresponding output coordonates.
c	A, B, x0, y0 are the parameters of this transformation
	Real*4 ImageIn(Nci,Nli), ImageOut(Nco,Nlo)
	Xc0=1+(x0+a*Xdo-b*Ydo-xdi)/dxi
	Yl0=1+(y0+a*Ydo+b*Xdo-ydi)/dyi
	ax=a*dxo/dxi
	bx=b*dxo/dxi
	ay=a*dyo/dyi
	by=b*dyo/dyi
	Ylid=Yl0
	Xcid=Xc0
	do ilo=1,nlo
	  Yli=Ylid
	  Xci=Xcid
	  do ico=1,nco
	    Call compar(Xci, Nci, ici, epsc)
	    Call compar(Yli, Nli, ili, epsl)
	    z=ImageIn(Ici,Ili)*(1-epsc)*(1.-epsl)
	    if(epsc.ne.0) z=z+(1-epsl)*epsc*ImageIn(ici+1,ili)
	    if(epsl.ne.0) z=z+(1-epsc)*epsl*ImageIn(ici,ili+1)
	    If(epsc.ne.0.or.epsl.ne.0) z=z+epsc*epsl*ImageIn(Ici+1,Ili+1)
	    ImageOut(Ico,Ilo)=z
	    Yli=Yli+by
	    Xci=Xci+ax
	  enddo
	  Xcid=Xcid-bx
	  Ylid=Ylid+ay
	Enddo
	return
	end
	Subroutine Compar(x,n,i,e)
	If(x.lt.1) then
	  i=1
	  e=0.
	else
	  if(x.gt.n) then
	    i=n
	    e=0.
	  else
	    i=x
	    e=x-i
	  endif
	endif
	return
	end
