c	SaiKi4 permettant une coupe transverse dans une image
c	avec differentes interpolations 
	Subroutine SaiKi4(ImageIn,Ncolumns,Nlines,Startx,Starty,Stepx,Stepy,
	1 StartxOut,StartyOut,EndxOut,EndyOut,NColumnsOut,NLinesOut,IlineOut,
	2 ImageOut,Option)
c	ImageIn		Working Image
c	Ncolumns	Corresponding number of columns
c	Nlines		----------------------- lines
c	Startx		------------- starting x
c	Starty		------------- -------- y
c	Stepx		------------- x step
c	Stepy		------------- y ----
c	StartxOut	x of first point for transverse line
c	StartyOut	y ----------------------------------
c	EndxOut		x of the last point
c	EndyOut		y -----------------
c	NcolumnsOut	Number of pixels in the transverse line
c	NLinesOut	--------- lines  -- --- output image
c	IlineOut	Receiving line
c	ImageOut	Receiving image
c	Option		Working Option
c	0	Near neighbour
c	1	Linear interpolation
c	2	Pseudo spline order 3
c	3	Pseudo spline order 5
c	4	B spline order 3
	Real*4 ImageIn(Ncolumns,Nlines), ImageOut(NcolumnsOut,NlinesOut)
	Integer*4 Option
	StepxOut=(EndxOut-StartxOut)/(NcolumnsOut-1)
	StepyOut=(EndyOut-StartyOut)/(NcolumnsOut-1)
	Do IcolumnOut=1,NcolumnsOut
	  Xval=StartxOut+(IcolumnOut-1)*StepxOut
	  Yval=StartyOut+(IcolumnOut-1)*StepyOut
	  If(Option.le.1) then
	    Call SaiGi2(ImageIn,Ncolumns,Nlines,Startx,Starty,Stepx,Stepy,
	1 Xval,Yval,ImageOut(IcolumnOut,IlineOut),Ic,Ec,Il,El,Option,Ierr)
	  else
	    Call SaiGi4(ImageIn,Ncolumns,Nlines,Startx,Starty,Stepx,Stepy,
	1 Xval,Yval,ImageOut(IcolumnOut,IlineOut),Ic,Ec,Il,El,Option,Ierr)
	  endif
	enddo
	return
	end

