c	SaiKi5 permettant une transformation polaire d'une image
c	avec differentes interpolations 
	Subroutine SaiKi5(ImageIn,Ncolumns,Nlines,Startx,Starty,Stepx,Stepy,
	1 StartxOut,StartyOut,NColumnsOut,NLinesOut,Radius,StepA,
	2 ImageOut,Option)
c	ImageIn		Working Image
c	Ncolumns	Corresponding number of columns
c	Nlines		----------------------- lines
c	Startx		------------- starting x
c	Starty		------------- -------- y
c	Stepx		------------- x step
c	Stepy		------------- y ----
c	StartxOut	x of first point for transverse line
c	StartyOut	y ----------------------------------
c	NcolumnsOut	Number of pixels in a radial profil
c	NLinesOut	--------- angles in the  output image
c	Radius		Maximum Radius
c	StepA		Step in angle in degree between two radial profiles
c	ImageOut	Receiving image
c	Option		Working Option
c	0	Near neighbour
c	1	Linear interpolation
c	2	Pseudo spline order 3
c	3	Pseudo spline order 5
c	4	B spline order 3
	Real*4 ImageIn(Ncolumns,Nlines), ImageOut(NcolumnsOut,NlinesOut)
	Integer*4 Option
	Stepa=360/(NlinesOut)
	Stepar=Stepa*3.14159/180.
	Do IlineOut=1,NlinesOut
	  Angle=(Ilineout-1)*Stepar
	  EndxOut=StartxOut+Radius*Cos(Angle)
	  EndyOut=StartyOut+Radius*Sin(Angle)
	  Call SaiKi4(ImageIn,Ncolumns,Nlines,Startx,Starty,Stepx,Stepy,
	1 StartxOut,StartyOut,EndxOut,EndyOut,NColumnsOut,NLinesOut,IlineOut,
	2 ImageOut,Option)
	enddo
	return
	end
