c.ps 60,68
c.hl 1 Image resampling by a 2d polynomial
c.x SAIKI7
c.x Image resampling> 2d polynomial
c.nf.ts 14,32
cA.Bijaoui	January 1985	Nice Observatory
c.f
c.ap ! But, Methode et Algorithme
c	Allows to resample all an Image using a 2d polynomial. The Input
cabcissae are reliated to Output abcissae as:
c	Xin=Polynomial(Xout,Yin)
c	5 possibilities are allowed for resampling (cf SaiGi3)
c.b.c; ^&Subroutines Used\&
c.nf.b.ts 16
cSai	SaiKi6
cAlgorithm	Ph1
c.f
c.b.c; ^&Call and Parameters\&
c.b;CALL SAIKI7(ImageIn, NcolumnsIn, NlinesIn, StartXIn, StepXIn, StartYIn,
cStepYIn, ImageOut, NcolumnsOut, FirstLine, LastLine, StepLine, NlinesOut,
cPolynomial, NdegX1, NdegY1, Option, Aux1)
c.b
c.nf.ts 14,27,30
cImageIn	R*4(NcolumnsIn,NlinesIn)	I	Input Image
cNcolumnsIn	I*4	I	Corresponding number of columns
cNlinesIn	I*4	I	Corresponding number of lines
cStartXin	R*4	I	Corresponding start x
cStepXIn	R*4	I	Corresponding x step
cStartYIn	R*4	I	Corresponding start y
cStepYIn	R*4	I	Corresponding y step
cImageOut	R*4(NcolumnsOut,NLinesOut)	O	Output Image
cNcolumnsOut	I*4	I	Corresponding number of columns
cFirstLine	I*4	I	First line to process in the image
cLastLine	I*4	I	Last line to process
cStepline	I*4	I	Step in line in processing
cNlinesOut	I*4	I	Number of lines in Output image
cStartXout	R*4	I	Corresponding start x
cStepXout	R*4	I	Corresponding x step
cPolynomial	R*4(Ndegx1,Ndegy1)	I	Array of the polynomial
c			coefficients
cNdegX1	I*4	I	Degree+1 in x direction for the polynomial
cNdegY1	I*4	I	Degree+1 in y direction
cOption	I*4	I	Option for resampling (Cf. above)
cAux1	R*4(Ndegx1)	O	Auxiliary array
cAux2	R*4(Ndegy1)	O	Auxiliary array
c.f
c.p;The NlinesOut is computed by:
c.c;NlinesOut=(LastLine-FirstLine)/Stepline+1
	Subroutine SAIKI7(ImageIn, NcolumnsIn, NlinesIn, StartXIn, StepXIn,
	1 StartYIn, StepYIn, ImageOut, NcolumnsOut, FirstLine, LastLine,
	2 StepLine, NlinesOut, StartxOut, StepXout,
	3 Polynomial, NdegX1, NdegY1, Option, Aux1, Aux2)
	Real*4 ImageIn(NcolumnsIn,NlinesIn), ImageOut(NcolumnsOut,NlinesOut)
	Real*4 Polynomial(Ndegx1,Ndegy1), Aux1(Ndegx1), Aux2(Ndegy1)
	Integer*4 FirstLine, StepLine, Option
	If(option.eq.0) option=1
	Yin=StartYin
	StepYOut=StepyIn*Stepline
	IlineOut=0
	Do iline=FirstLine,LastLine,StepLine
	  IlineOut=IlineOut+1
	  Do idegx=1,Ndegx1
	    do idegy=1,ndegy1
	      aux2(idegy)=Polynomial(Idegx,Idey)
	    enddo
	    Call Ph1(Aux1(Idegx),Yin,Ndegy1,Aux2)
	  enddo
	  call SaiKI6(ImageIn(1,Iline), StartxIn, StepxIn, NcolumnsIn,
	1 ImageOut(1,Ilineout), StartXout, StepXOut, NcolumnsOut, Aux1,
	2 Ndeg1, Option)
	  Yin=Yin+StepYout
	Enddo
	Return
	End
