	SubRoutine SaiMi12(Image1, Nc, Nl, Image2, Centre, ElPar, Start, Step, 
	1 ImageOut, Size)

	IMPLICIT NONE

	INTEGER*4
	1 I,				!Current index
	1 Ic,				!Current Column Index
	1 Il,				!Current Line Index
	1 Nc,				!Number of columns
	1 Nl				!Number of lines

	REAL*4
	1 A,				!Orientation in radian units
	1 Atan,				!Function Atan
	1 Ca,				!Cos(a)
	1 Centre(2),			!Central Coordinates
	1 Elpar(3),			!Ellipticity parametres
	1 F1,				!reliated to the major axis
	1 F2,				!reliated to the minor axis
	1 Image1(Nc,Nl),		!Working Image
	1 Image2(Nc,Nl),		!Working Image
	1 ImageOut(Nc,Nl),		!Resulting Image
	1 Pcentre(2),			!Central Coordinates (Pixel)
	1 Q,				!Elliptical distance (Pixel)
	1 Qmax,				!Maximum distance for meaning
	1 Qmin,				!Minimum  distance for meaning
	1 Qa2,				!Qmax**2
	1 Qi2,				!Qmin**2
	1 Sa,				!Sin(a)
	1 Size,				!Size Factor
	1 Start(2),			!Starting Coordinates
	1 Step(2),			!Sampling steps
	1 Weight,			!Weight parametre
	1 X,				!Current abcissa
	1 Xc,				!X*ca
	1 Xs,				!X*sa
	1 Y,				!Current ordinate
	1 Yc,				!Y*ca
	1 Ys				!Y*sa

	Do i=1,2
	  Pcentre(i)=(Centre(i)-Start(i))/Step(i)+1
	Enddo
	A=ElPar(3)*Atan(1.)/45.
	F1=(Step(1)/Elpar(1))**2
	F2=(Step(1)/Elpar(2))**2
	Qmax=1+size
	Qmin=1-size
	Qa2=Qmax**2
	Qi2=Qmin**2
	Y=1-Pcentre(2)
	Ca=Cos(a)
	Sa=Sin(a)

	Do Il=1,Nl
	  Ys=Y*sa
	  Yc=Y*ca
	  X=1-Pcentre(1)
	  Do Ic=1,Nc
	    Xc=X*ca
	    Xs=X*sa
	    Q=F2*(Xc-Ys)**2+F1*((Xs+Yc)**2)
	    If(Q.le.Qi2) Weight=1.
	    If(Q.ge.Qa2) Weight=0.
	    If(Q.gt.Qi2.and.Q.lt.Qa2) Weight=(Qmax-Sqrt(Q))/(2.*size)
	    ImageOut(Ic,Il)=Image1(Ic,Il)*Weight+Image2(Ic,Il)*(1.-weight)
	    X=X+1
	  Enddo
	  Y=Y+1
	Enddo

	Return
	End

