c.ps 60,68
c.hl 1 Integration in simple fields
c.x SAIPH1
c.x Photometry> Integration in square, Circle
c.nf.ts 14,32
cA.Bijaoui	85/3	Nice Observatory
c.f
c.ap
c	Allows integration in simple fields, defined in discrete geometry,
cwith uniform weights.
c.b.c; ^&Call and Parameters\&
c.b;CALL SAIPh1(ImageIn, Ncolumns, Nlines, ColumnCenter, LineCenter, Size,
cOption, Flux, Status)
c.b
c.nf.ts 14,27,30
cImageIn	R*4(Ncolumns,Nlines)	I	Input image
cNcolumns	I*4	I	Corresponding number of columns
cNlines	I*4	I	Corresponding number of lines
cColumnCenter	I*4	I	Central column for integration
cLineCenter	I*4	I	Central line for integration
cSize	I*4	I	Parameter of size of the integration field
cOption	I*4	I	Option for integration:
c			0 square (Side size= 2size+1)
c			1 Discrete circle (radius=size)
cFlux	R*4	O	Result for integration
cStatus	I*4	O	if status=0 no problem
c			if status=1 too near for edges
c.f
c.p;If status=1 the result is computed taking into account an extrapolation with
cthe same value than the first pixel (or last pixel).
	Subroutine SAIPh1(ImageIn, Ncolumns, Nlines, ColumnCenter,
	1 LineCenter, Size, Option, Flux, Status)
	Real*4 ImageIn(Ncolumns,Nlines)
	Integer*4 ColumnCenter, LineCenter, Option, Status, Size
	Status=0
	Nc1=ColumnCenter-Size
	Nc2=ColumnCenter+size
	Nl1=LineCenter-Size
	Nl2=LineCenter+size
	If((nc1.lt.1).or.(nl1.lt.1).or.(nc2.gt.Ncolumns).or.(Nl2.gt.Nlines))
	1 then
	  Status=1
	  Flux=0.
	  return
	endif
	Flux=0.
	Do Iline=nl1,nl2
	  If(status.eq.1) then
	    Il=Max0(Iline,1)
	    Il=Min0(Iline,Nlines)
	  else
	    Il=Iline
	  endif
	  Do Icolumn=Nc1,Nc2
	    If(status.eq.1) then
	      Ic=Max0(Icolumn,1)
	      Ic=Min0(Icolumn,Ncolumns)
	    else
	      Ic=Icolumn
	    Endif
	    If(option.eq.0) then
	      Flux=flux+ImageIn(Ic,Il)
	    Else
	      Distance=sqrt(float(Icolumn-ColumnCenter)**2+float(Iline-
	1              linecenter)**2)
	      Idistance=Ifix(distance)
	      If(Idistance.le.Size) Flux=Flux+ImageIn(Ic,il)
	    endif
	  enddo
	enddo
	return
	end
