c.ps 60,68
c.hl 1 Integration in fields, with weights
c.x SAIPH2
c.x Photometry> Integration with weights
c.nf.ts 14,32
cA.Bijaoui	85/3	Nice Observatory
c.f
c.ap
c	Allows integration in fields, defined in real geometry,
cwith weights.
c	3 Option are available:
c.ls.le;Integration in a circle, defined in physical space. We introduce a
cparameter for "fuzzy" edge
c.le;Integration with a gaussian ponderation
c.le;Integration with a gaussian ponderation, with a zero mean.
c.b;That allows to substract the mean component (background)
c.b.c; ^&Call and Parameters\&
c.b;CALL SAIPh2(ImageIn, Ncolumns, Nlines, StartX, StepX, StartY, StepY,
cXCenter, YCenter, Size, Coeff, Option, Background, Flux, Status)
c.b
c.nf.ts 14,27,30
cImageIn	R*4(Ncolumns,Nlines)	I	Input image
cNcolumns	I*4	I	Corresponding number of columns
cNlines	I*4	I	Corresponding number of lines
cStartX	R*4	I	Corresponding starting x
cStepX	R*4	I	Corresponding x step
cStartY	R*4	I	Corresponding starting y
cStepY	R*4	I	Corresponding y step
cXCenter	R*4	I	Central abcissa for integration
cYCenter	R*4	I	Central Ordinate for integration
cSize	I*4	I	Parameter of size of the integration field
cCoeff	R*4	I	Coefficient for the integration:
c			Option 1: Fuzzy parameter (percentage of size)
c			Option 2,3: Gaussian size (in physical units)
cOption	I*4	I	Option for integration:
c			1 Circle
c			2 Gaussian
c			3 Gaussian with background substraction
cBackground	R*4	I	Background to substract
cFlux	R*4	O	Result for integration
cStatus	I*4	O	if status=0 no problem
c			if status=1 too near from edges
c.f
c.p;If status=1 the result is computed taking into account an extrapolation 
cwith the same value than the first pixel (or last pixel).
	Subroutine SAIPh2(ImageIn, Ncolumns, Nlines, StartX, StepX, StartY,
	1 StepY, Xcenter, Ycenter, Size, Coeff, Option, Background,
	2 Flux, Status)
	Real*4 ImageIn(Ncolumns,Nlines)
	Integer*4 ColumnCenter, LineCenter, Option, Status, Size, Sizemax
	Status=0
	Sizemax=size+1
	If(option.eq.1) then
	  sizemax=ifix(float(size)*(1+coeff))+1
	      Radius=Size*stepx
	      Alr=Radius*Coeff
	      Rmax=Radius+Alr
	      Rmin=Radius-Alr
	      RA=RMAX**2
	      RI=RMIN**2
	else
	  u=-0.5/(coeff*coeff)
	  q=size*size*stepx*stepx
	endif
	ColumnCenter=Ifix((Xcenter-Startx)/StepX)+1
	LineCenter=Ifix((Ycenter-Starty)/stepy)+1
	Nc1=ColumnCenter-Sizemax
	Nc2=ColumnCenter+sizemax
	Nl1=LineCenter-Sizemax
	Nl2=LineCenter+sizemax
	If((nc1.lt.1).or.(nl1.lt.1).or.(nc2.gt.Ncolumns).or.(Nl2.gt.Nlines))
	1 then
	  status=1
	  flux=0.
	  return
	endif
	Flux=0.
	Sum1=0.
	Sum2=0.
	Sum0=0.
	sig1=0.
	Sig0=0.
	Do Iline=nl1,nl2
	Y=Starty+(Iline-1)*stepy
	Yp=(y-ycenter)**2
	  If(status.eq.1) then
	    Il=Max0(Iline,1)
	    Il=Min0(Iline,Nlines)
	  else
	    Il=Iline
	  endif
	  Do Icolumn=Nc1,Nc2
	    x=startx+(Icolumn-1)*Stepx
	    xp=(x-xcenter)**2
	    If(status.eq.1) then
	      Ic=Max0(Icolumn,1)
	      Ic=Min0(Icolumn,Ncolumns)
	    else
	      Ic=Icolumn
	    Endif
	      R2=Xp+Yp
	    If(Option.eq.1) then
 	      IF(R2.Le.RI) then 
	        flux=flux+ImageIn(Ic,Il)-background
	      else
 	        IF(R2.le.RA) then
	          R2=SQRT(R2)
 	          POIDS=(RMAX-R2)/(2.*ALR)
		  flux=flux+poids*(ImageIn(ic,il)-Background)
		endif
	      endif
	    else
	      if(r2.le.q) then
	      sum0=sum0+1
	      weight=exp(u*(xp+yp))
	      sum1=sum1+weight
	      sum2=sum2+weight*weight
	      sig0=sig0+(ImageIn(ic,Il)-background)
	      sig1=sig1+weight*(ImageIn(Ic,Il)-background)
	      endif
	    endif
	  enddo
	enddo
	If(Option.eq.2) Flux=sig1/sum2
	If(Option.eq.3) Flux=(sig0*sum1-sig1*sum0)/(sum1*sum1-sum0*sum2)
	return
	end
