cA.Bijaoui	85/2	Nice Observatory
c	Allows the Fourier transform of an image line by line
	Subroutine SaiTi1(ImageInR, ImageInI, Ncolumns, Nlines, Exp,
	1 ImageOutR, ImageOutI, X, Y, Ierr, Option)
cImageInR	R*4(Ncolumns,Nlines)	I	Working Image
cImageInI	R*4(Ncolumns,Nlines)	I	corresponding imaginary part
cNcolumns	I*4	I	Corresponding number of columns
c			Ncolumns = 2** Exp
cNlines	I*4	I	Corresponding number of lines
cExp	I*4	I	Exponent for the number of columns
cImageOutR	R*4(Ncolumns,Nlines)	O	Real part of each FFT line
cImageOUtI	R*4(Ncolumns,Nlines)	O	corresponding imaginary part
cX	R*4(Ncolumns)	O	aux array
cY	R*4(Ncolumns)	O	aux array
cIerr	I*4	O	Error parameter
c			Ierr=1 Ncolumns ne 2**exp
c			Ierr=2 Bad option value
cOption	I*4	I	Working Option
c			 1 Direct  transform
c			-1 Inverse transform
	Real*4 ImageInR(Ncolumns, Nlines), ImageOutR(Ncolumns,Nlines),
	1 ImageInI(Ncolumns,Nlines), ImageOutI(Ncolumns,Nlines),
	2 X(Ncolumns), Y(Ncolumns)
	Integer*4 Exp,Option
	Ierr=0
	Nc=2**Exp
	If(Nc.ne.Ncolumns) then
	  Ierr=1
	  return
	endif
	If(Option.ne.1.and.Option.ne.-1) then
	  Ierr=2
	  return
	endif
	Do Iline=1,Nlines
	  Do Icolumn=1,Ncolumns
	    X(icolumn)=ImageInR(Icolumn,Iline)
	    Y(icolumn)=ImageInI(Icolumn,Iline)
	  enddo
	  Call FFt(x,y,exp,Option)
	  Do Icolumn=1,Ncolumns
	    ImageOutR(Icolumn,Iline)=X(Icolumn)
	    ImageOutI(Icolumn,Iline)=Y(Icolumn)
	  Enddo
	Enddo
	Return
	end
c	h.touma a.bijaoui 18 mai 1984
c	sous-programme de transformation de fourier
	subroutine fft(x,y,m,is)
	dimension x(1),y(1)
	n=2**m
	do lo=1,m
		lmx=2**(m-lo)
		lix=2*lmx
		scl=6.283185/float(lix)
		do lm=1,lmx
			arg=float(lm-1)*scl
			c=cos(arg)
			s=-float(is)*sin(arg)
			do li=lix,n,lix
				j1=li-lix+lm
				j2=j1+lmx
				t1=x(j1)-x(j2)
				t2=y(j1)-y(j2)
				x(j1)=x(j1)+x(j2)
				y(j1)=y(j1)+y(j2)
				x(j2)=c*t1+s*t2
				y(j2)=c*t2-s*t1
			enddo
		enddo
	enddo
	nv2=n/2
	j=1
	nm1=n-1
	do i=1,nm1
		if(i.lt.j) then
			t10=x(j)
			t11=y(j)
			x(j)=x(i)
			y(j)=y(i)
			x(i)=t10
			y(i)=t11
		endif
		k=nv2
20		if(k.lt.j) then
			j=j-k
			k=k/2
			goto 20
		endif
		j=j+k
	enddo
	an=float(n)
	if(is.eq.-1) then
	  do i=1,n
	    x(i)=x(i)/an
	    y(i)=y(i)/an
	  enddo
	endif
	return
	end
